!
! $Id: modinitvars.F,v 1.4 2004/06/25 15:04:24 pmarches Exp $
!
C     AGRIF (Adaptive Grid Refinement In Fortran)
C
C     Copyright (C) 2003 Laurent Debreu (Laurent.Debreu@imag.fr)
C                        Christophe Vouland (Christophe.Vouland@imag.fr)    
C
C     This program is free software; you can redistribute it and/or
C     modify
C     it under the terms of the GNU General Public License as published
C     by
C     the Free Software Foundation; either version 2 of the License, or
C     (at your option) any later version.
C
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU General Public License for more details.
C
C     You should have received a copy of the GNU General Public License
C     along with this program; if not, write to the Free Software
C     Foundation, Inc., 59 Temple Place -  Suite 330, Boston, MA
C     02111-1307, USA.
C
C
C
CCC   Module AGRIF_Init_Vars
C
      Module AGRIF_Init_Vars
C
CCC   Description:
CCC   Initialization of the variables of the current grid.
C
C     Modules used: 
C      
      Use Agrif_Types
C   
      Contains
C     Defininition of the procedures contained in this module 
C  
C 
C
C     ************************************************************************** 
CCC   Subroutine Agrif_Create_var 
C     ************************************************************************** 
C  
      Subroutine Agrif_Create_Var_Alloc(AGRIF_GR)
C
CCC   Description:
CCC   Allocation of the field "var" of the grid variables.
C
CC    Method:              
C 
C     Declarations:
C
      Implicit none
C
C     Pointer argument:
      Type(AGRIF_grid), Pointer :: AGRIF_GR   ! Pointer on the current
                                              ! grid 
c       Interface
c#include "createvar_alloc_interface_agrif.h"
c       End Interface
C
C      
c#include "createvar_alloc_calls_agrif.h"
C
C           
      End Subroutine Agrif_Create_Var_Alloc
C
C
C
C
C    
C
C
C     ************************************************************************** 
CCC   Subroutine Agrif_Create_var_List 
C     ************************************************************************** 
C  
      Subroutine Agrif_Create_Var_List(AGRIF_GR)  
C
CCC   Description:
CCC   Array "tabvars" of the current grid.
C
CC    Method:              
C 
C     Declarations:
C
      Implicit none
C
C     Pointer argument:
      Type(AGRIF_grid), Pointer :: AGRIF_GR   ! Pointer on the current
                                              ! grid
C
C
#include "createvarlist_agrif.h"      
C
C      
      End Subroutine Agrif_Create_Var_List      
C
C     ************************************************************************** 
CCC   Subroutine Agrif_Create_var 
C     ************************************************************************** 
C  
      Subroutine Agrif_Create_Var(AGRIF_GR)
C
CCC   Description:
CCC   Allocation of the field "var" of the grid variables.
CCC   Fields "root_var", "nbdim" and "parent_var" of the grid variables.
CCC   Array "tabvars" of the current grid. 
CCC   Field "namevar" of the grid variables.
C
CC    Method:                  
C 
C     Declarations:
C
      Implicit none
C
C     Pointer argument:
      Type(AGRIF_grid), Pointer :: AGRIF_GR   ! Pointer on the current
                                              ! grid
      Integer :: nb
C 
C
C     Allocation of the field "var" of the grid variables. 
c     Call Agrif_Create_Var_Alloc
c    &     (AGRIF_GR)

C
C     Array "tabvars" of the current grid. 

      Allocate(Agrif_Gr % tabvars(Agrif_NbVariables))
      Do nb = 1, Agrif_NbVariables
        Allocate(Agrif_Gr % tabvars(nb) % var)
      End Do

      Call Agrif_Create_Var_List
     &     (AGRIF_GR)
C 
C     Fields "root_var", "nbdim" and "parent_var" of the grid variables.     
      If (Agrif_Gr % fixedrank .NE.0) Then
      Do nb = 1, Agrif_NbVariables
     
       Agrif_Gr % tabvars(nb) % parent_var => 
     &       Agrif_Gr % parent %tabvars(nb)
       Agrif_Gr % tabvars(nb) % var % nbdim =
     &       Agrif_Mygrid % tabvars(nb) % var % nbdim
       Agrif_Gr % tabvars(nb) % var % root_var =>
     &       Agrif_Mygrid % tabvars(nb) % var
          
      End Do
      End If

C
C     Field "namevar" of the grid variables.

#include "createvarname_agrif.h"     
C
C           
      End Subroutine Agrif_Create_Var
C
      End Module AGRIF_Init_Vars      

c#include "createvar_alloc_agrif.h"

