%s character
%{
#include <math.h>
#include <stdlib.h>
#include <string.h>
int line_num=1;
int line_num_common=1;
extern FILE * yyin;
#define MAX_INCLUDE_DEPTH 30
YY_BUFFER_STATE include_stack[MAX_INCLUDE_DEPTH];
int include_stack_ptr_fortran=0;
int c;
int confirmyes;
 char *chardim;
%}

COMMENT "%"  			
SEPARATEUR "::"
NIMPORTEQUOI .
COMMENTAIRES1 {COMMENT}{NIMPORTEQUOI}*{COMMENT}
PROBTYPE "1D"|"2D"|"3D"			
INTERPTYPE "LINEAR"|"LAGRANGE"|"SPLINE"|"USER_INIT"	 
UPDATETYPE "copy"|"average"|"full_weighting"|"USER_UPDATE"			
VARTYPE "TYPE"					
COMMON "common"					
SLASH "/"
USEITEM "FIXED_GRIDS"|"ONLY_FIXED_GRIDS"|"MASK"
AMRTYPE real|integer|logical|character|real\*8	
RAFFINEMENT "RAF"			
NAME [a-zA-Z\_][a-zA-Z0-9\_]*
DIGIT [0-9]+
OP "+"|"-"|"*"|"/"
NUM {DIGIT}
SGN "+"|"-"
NEXTLINE \n+[ \t]+"$"|\n+[ \t]+"&"
FILENAME {NAME}"."{NAME}
%%

parent return TOK_TOPARENT;
interp return TOK_INTERP;		/* interpolation of the grid variable */       
bc return TOK_BC;			/* calculation of the boundary conditions */
regridding return TOK_REGRIDDING;	/* period of regridding */
coeffrefx return TOK_COEFFRAFX;		/* space refinement factor in the x direction */
coeffrefy return TOK_COEFFRAFY;		/* space refinement factor in the y direction */
coeffrefz return TOK_COEFFRAFZ;		/* space refinement factor in the z direction */
coeffreftx return TOK_COEFFRAFTX;	/* time refinement factor in the x direction */
coeffrefty return TOK_COEFFRAFTY;	/* time refinement factor in the y direction */
coeffreftz return TOK_COEFFRAFTZ;	/* time refinement factor in the z direction */
restore return TOK_TORESTAURE;		/* restoration */
update return TOK_TOUPDATE;		/* update */
paramfile return TOK_COMMONFILE;	/* name of the common file */ 
bcinterp return TOK_BCINTERP;		/* kind of interpolation for the calculation of the boundary
					   conditions */
efficiency return TOK_EFFICIENCY;	/* efficiency for the adaptive refinement */
rafmax return TOK_RAFMAX;	/* minimum size in all directions */
rafmaxx return TOK_RAFMAXX;	/* minimum size in x direction */
rafmaxy return TOK_RAFMAXY;	/* minimum size in y direction */
rafmaxz return TOK_RAFMAXZ;	/* minimum size in z direction */
include {return TOK_INCLUDE;}
use return TOK_USE;


minwidth return TOK_MINWIDTH;		/* minimum width of rectangles for the adaptive refinement */
BEGINSTATICVARS {instatic=1;}
ENDSTATICVARS {instatic=0;}
STATICCOMMON return TOK_STATIC_COMMON;
STATICVARS return TOK_STATIC_VARS;	

{COMMENTAIRES1} {}
{COMMON} {return TOK_COMMON;}		/* name of the common file */
{SLASH} {return TOK_SLASH;}
{SEPARATEUR} {return TOK_SEP;}
{NEXTLINE} {line_num_common++;}
{FILENAME} {strcpy(yylval.na,yytext); return TOK_FILENAME;}
{USEITEM} {strcpy(yylval.na,yytext); return TOK_USEITEM;}
{PROBTYPE} {strcpy(yylval.na,yytext); return TOK_PROBTYPE;}	/* dimension of the problem */
{INTERPTYPE} {strcpy(yylval.na,yytext); return TOK_INTERPTYPE;}	/* kind of interpolation */
{UPDATETYPE} {strcpy(yylval.na,yytext); return TOK_UPDATETYPE;}	/* kind of update */
{VARTYPE} {return TOK_VARTYPE;}		/* position of the grid variable on the cells of the mesh */
{RAFFINEMENT} {return TOK_RAF;}		/* type of each space dimension */
{AMRTYPE} {strcpy(yylval.na,yytext);return TOK_TYPE;}	/* type of the grid variable */
{NAME} {strcpy(yylval.na,yytext);return TOK_NAME;}
{OP} {strcpy(yylval.na,yytext);return TOK_OP;}
{NUM} {yylval.ival=atoi(yytext);return TOK_NUM;}
;|\,|\(|\)|:|\[|\] {return (int) *yytext;}
\n {line_num++;line_num_common++;return (int) *yytext;}

[ \t]+ ;



%%
