#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "decl.h"
char lvargridname[LONGNOM];
char lvargridname2[LONGNOM];

int
max (int i, int j)
{
  if (i > j)
    return i;
  else
    return j;
}

int
max3 (int i, int j, int k)
{
  int res, interm;
  if (i > j)
    interm = i;
  else
    interm = j;
  if (interm > k)
    res = interm;
  else
    res = k;
  return res;
}

int
min (int i, int j)
{
  if (i > j)
    return j;
  else
    return i;
}

void
tofich_reste (FILE * filout, char *s)	/* ecrit la chaine de caractere s dans le fichier filout */
{
  char temp[66];

  if (strlen (s) < 65)
    {
      fprintf (filout, "     & %s\n", s);
    }
  else
    {
      strncpy (temp, s, 65);
      strcpy (&temp[65], "\0");
      fprintf (filout, "     & %s\n", temp);
      tofich_reste (filout, (char *) &s[65]);
    }
}

void
tofich (FILE * filout, char *s)	/* ecrit la chaine de caractere s dans le fichier filout */
{
  char temp[66];
  if (strlen (s) < 65)
    {
      fprintf (filout, "      %s\n", s);
    }
  else
    {
      strncpy (temp, s, 65);

      strcpy (&temp[65], "\0");
      fprintf (filout, "      %s\n", temp);
      tofich_reste (filout, (char *) &s[65]);
    }
}


void
comment (FILE * filout, char *s)	/* ecrit le commentaire de caractere s dans le fichier filout */
{
  fprintf (filout, "C%s\n", s);
}

void
nline (FILE * filout, int number)	/* passe number lignes dans le fichier filout */
{
  int i;
  for (i = 0; i < number; i++)
    fprintf (filout, "\n");
}

void
printvar (FILE * filout, variable * v)
/* ecrit la variable v et sa declaration dans le fichier filout
Valable uniquement pour les tableaux associes a une variable du modele
*/
{
  char ligne[LONGLIGNE];
  sprintf (ligne, "     TYPE(AGRIF_PVARIABLE) :: %s", v->nomvar);
  if (v->common == 1)
    {
      strcat (ligne, "_");
      strcat (ligne, v->commonname);
    }
  tofich (filout, ligne);
}

char *
lastdim (variable * var)	/* retourne une chaine de caractere contenant
				   la derniere dimension de la variable v */
{
  char ligne[LONGLIGNE];
  char lignedim[LONGLIGNE];
  char d[LONGLIGNE];
  typedim dim;
  listdim *newdim;
  newdim = var->dimension;
  if (!newdim)
    return "";

  while (newdim->suiv)
    {
      newdim = newdim->suiv;
    }

  dim = newdim->dim;
  strcpy (d, dim.first);
  strcat (d, ":");
  strcat (d, dim.last);

  return d;
}

char *
lastdimint (variable * var)	/* retourne une chaine de caractere contenant
				   l'intervalle de la derniere dimension de la variable v */
{
  char ligne[LONGLIGNE];
  char lignedim[LONGLIGNE];
  char d[LONGLIGNE];
  typedim dim;
  listdim *newdim;
  newdim = var->dimension;
  if (!newdim)
    return "";

  while (newdim->suiv)
    {
      newdim = newdim->suiv;
    }

  dim = newdim->dim;
  strcpy (d, dim.first);
  strcat (d, ",");
  strcat (d, dim.last);

  return d;
}

char *varcommonname(variable * var)
{
  char *ligne;
  int longueur;
  
  longueur=strlen(var->nomvar);
  if (var->common == 1)
    {
  longueur=longueur+1+strlen(var->commonname);
    }
    
    longueur=longueur+1;
      
  ligne = (char *) malloc (longueur * sizeof (char));

  strcpy (ligne, var->nomvar);
  if (var->common == 1)
    {
      strcat (ligne, "_");
      strcat (ligne, var->commonname);
    } 
     
  return ligne;  
}

char *
basevariablename (variable * var)
{
  char *ligne;
  int longueur;
  
  longueur = strlen(varcommonname(var))+15;

  ligne = (char *) malloc (longueur * sizeof (char));

  sprintf (ligne, "Agrif_Gr % %%s", varcommonname(var));

  return ligne;
}

char *
variablename (variable * var)
{
  char *ligne;

  ligne = (char *) malloc (LONGLIGNE * sizeof (char));

  sprintf (ligne, "Agrif_Gr % %%s", varcommonname(var));

  strcat (ligne, " %var");
  return ligne;
}

char *
variablenameroot (variable * var)
{
  char *ligne;

  ligne = (char *) malloc (LONGLIGNE * sizeof (char));

  sprintf (ligne, "Agrif_Mygrid %% %s", varcommonname(var));

  strcat (ligne, " %var");
  return ligne;
}

char *
basevariablenameparent (variable * var)
{
  char *ligne;

  ligne = (char *) malloc (LONGLIGNE * sizeof (char));

  sprintf (ligne, "Agrif_Gr %% parent %% %s", varcommonname(var));

  return ligne;
}

char *
variablenameparent (variable * var)
{
  char *ligne;

  ligne = (char *) malloc (LONGLIGNE * sizeof (char));

  sprintf (ligne, "Agrif_Gr %% parent %% %s", varcommonname(var));

  strcat (ligne, " %var");
  return ligne;
}

char *
vararrayname (variable * var)	/* retourne une chaine de caractere contenant
				   le nom de la variable v */
{
  char *ligne;

  ligne = (char *) malloc (LONGLIGNE * sizeof (char));

  if (!strcasecmp (var->typevar, "REAL"))
    {
      sprintf (ligne, "%%array%d", var->nbdim);
    }
  else if (!strcasecmp (var->typevar, "REAL*8"))
    {
      sprintf (ligne, "%%darray%d", var->nbdim);
    }
  else if (!strcasecmp (var->typevar, "INTEGER"))
    {
      sprintf (ligne, "%%iarray%d", var->nbdim);
    }
  else if (!strcasecmp (var->typevar, "LOGICAL"))
    {
      sprintf (ligne, "%%larray%d", var->nbdim);
    }
  else if (!strcasecmp (var->typevar, "CHARACTER"))
    {
      sprintf (ligne, "%%carray%d", var->nbdim);
    }

  return ligne;
}

char *
vargridname (variable * var)	/* retourne une chaine de caractere contenant
				   le nom de la variable v */
{
  char *ligne;
  char *ligne2;

  sprintf (lvargridname, "%s", variablename (var));
  if (!strcasecmp (var->typevar, "REAL"))
    {
      sprintf (lvargridname2, "%%array%d", var->nbdim);
    }
  else if (!strcasecmp (var->typevar, "REAL*8"))
    {
      sprintf (lvargridname2, "%%darray%d", var->nbdim);
    }
  else if (!strcasecmp (var->typevar, "INTEGER"))
    {
      sprintf (lvargridname2, "%%iarray%d", var->nbdim);
    }
  else if (!strcasecmp (var->typevar, "LOGICAL"))
    {
      sprintf (lvargridname2, "%%larray%d", var->nbdim);
    }
  else if (!strcasecmp (var->typevar, "CHARACTER"))
    {
      sprintf (lvargridname2, "%%carray%d", var->nbdim);
    }

  strcat (lvargridname, lvargridname2);

  return lvargridname;
}

char *
curbasevariablename (variable * var)
{
  char *ligne;
  int longueur;
  
  longueur = strlen(varcommonname(var))+20;
  
  ligne = (char *) malloc (longueur * sizeof (char));

  sprintf (ligne, "Agrif_Curgrid % %%s", varcommonname(var));

  return ligne;
}

char *
curvariablename (variable * var)
{
  char *ligne;
  int longueur;
  
  longueur = strlen(varcommonname(var))+26;
  
  ligne = (char *) malloc (longueur * sizeof (char));

  sprintf (ligne, "Agrif_Curgrid % %%s", varcommonname(var));

  strcat (ligne, " %var");
  return ligne;
}

char *
curbasevariablenameparent (variable * var)
{
  char *ligne;
  int longueur;
  
  longueur = strlen(varcommonname(var))+30;
  
  ligne = (char *) malloc (longueur * sizeof (char));

  sprintf (ligne, "Agrif_Curgrid %% parent %% %s", varcommonname(var));

  return ligne;
}

char *
curvariablenameparent (variable * var)
{
  char *ligne;
  int longueur;
  
  longueur = strlen(varcommonname(var))+35;
  
  ligne = (char *) malloc (longueur * sizeof (char));

  sprintf (ligne, "AGRIF_CURGRID %% parent %% %s", varcommonname(var));

  strcat (ligne, " %var");
  return ligne;
}

char *
curvargridname (variable * var)	/* retourne une chaine de caractere contenant
				   le nom de la variable v */
{
  char *ligne;
  char *ligne2;

  ligne = (char *) malloc (LONGLIGNE * sizeof (char));
  ligne2 = (char *) malloc (LONGLIGNE * sizeof (char));

  sprintf (ligne, "%s", curvariablename (var));
  if (!strcasecmp (var->typevar, "REAL"))
    {
      sprintf (ligne2, "%%array%d", var->nbdim);
    }
  else if (!strcasecmp (var->typevar, "REAL*8"))
    {
      sprintf (ligne2, "%%darray%d", var->nbdim);
    }
  else if (!strcasecmp (var->typevar, "INTEGER"))
    {
      sprintf (ligne2, "%%iarray%d", var->nbdim);
    }
  else if (!strcasecmp (var->typevar, "LOGICAL"))
    {
      sprintf (ligne2, "%%larray%d", var->nbdim);
    }
  else if (!strcasecmp (var->typevar, "CHARACTER"))
    {
      sprintf (ligne2, "%%carray%d", var->nbdim);
    }

  strcat (ligne, ligne2);

  return ligne;
}


char *
vargridparam (variable * v)	/* retourne une chaine de caractere contenant
				   la liste des dimensions de la variable v */
{
  char* d;
  typedim dim;
  listdim *newdim;
  newdim = v->dimension;
  if (!newdim)
    return "";

  d=(char *)malloc(LONGLIGNE*sizeof(char));
  strcpy (d, "(");
  while (newdim)
    {
      dim = newdim->dim;
      strcat (d, dim.first);
      strcat (d, ":");
      strcat (d, dim.last);
      newdim = newdim->suiv;
      if (newdim)
	{
	  strcat (d, ",");
	}
    }

  strcat (d, ")");
  strcat (d, "\0");
  return d;
}

char *
dim1 (variable * v)		/*retourne une chaine de caractere contenant la dimension selon 
				   la verticale */
{
  char d[LONGLIGNE];
  typedim dim;
  listdim *newdim;

  newdim = v->dimension;
  dim = newdim->dim;

  sprintf (d, "%s:%s", dim.first, dim.last);

  return d;
}

char *
dim3 (variable * v)		/*retourne une chaine de caractere contenant la dimension selon 
				   la verticale */
{
  char d[LONGLIGNE];
  typedim dim;
  listdim *newdim;

  newdim = v->dimension;

  newdim = newdim->suiv;
  newdim = newdim->suiv;
  dim = newdim->dim;

  sprintf (d, "%s:%s", dim.first, dim.last);

  return d;
}

char *
dim4 (variable * v)		/*retourne une chaine de caractere contenant la dimension selon 
				   le temps */
{
  char d[LONGLIGNE];
  typedim dim;
  listdim *newdim;

  newdim = v->dimension;

  newdim = newdim->suiv;
  newdim = newdim->suiv;
  newdim = newdim->suiv;
  dim = newdim->dim;

  sprintf (d, "%s:%s", dim.first, dim.last);

  return d;
}

FILE *
associate (char *filename)
{
  char filefich[LONGNOM];
  strcpy (filefich, nomdir);
  strcat (filefich, "/");
  strcat (filefich, filename);
  return fopen (filefich, "w");
}

void
creefichieramr ()
{
  char ligne[LONGLIGNE*100];
  char temp[LONGLIGNE], temp1[LONGLIGNE], temp2[LONGLIGNE], temp3[LONGLIGNE],
    temp4[LONGLIGNE];
  listdim *newdim;
  listvar *newvar;
  listnom *l;
  variable *v;
  typedim dim;
  lpoint *lpt;
  int restauration, cmpt, erreur;
  char filefich[LONGNOM];
  char lignetemp[LONGLIGNE];
  int i;
  int nbvarn;
  int ci, cj; 
  int cpt; 
  char *nomcommon;
  listcommons *commonliste;
  int nbvariablesparalloc,nbvarcur ;
  int numerocourant;

  FILE *griddata, *typedata, *initproc, *allocproc, *deallocprocbefore;
  FILE *deallocprocafter;
  FILE *instanceproc, *inclproc, *interproc, *settimestep, *util, *oldlevel,
    *timeinit;
  FILE *setxstep, *setystep, *savelevel, *copylevel, *nullify, *update,
    *create_v;
  FILE *initvoisins, *voisins, *parents;
  FILE *filecommon, *create_v1, *create_v2, create_v3;
  FILE *instancebaseproc, *probdim;
  FILE *backinstance, *backinstance_commons;
  FILE *parentvar;
  FILE *instanceparents;
  FILE *createvarlist;
  FILE *createvarname,*keys;
  FILE *clustering; 
  FILE *tempfile;
  FILE *freerestore,*allocrestore;
  FILE *indicespoints,*declindicespoints;
  FILE *alloccalls,*createvaralloccalls;
  int j;
  int backopen;
  float res;
  

  printf ("\n************\n");

/* test de certains parametres d' entrees*/
  erreur = tests_entrees ();
  if (erreur)
    exit (0);
  else
    printf ("CONV : Ok\n");
  printf ("Installing AGRIF include files in directory %s\n", nomdir);
  printf ("Installing new model common files in directory %s\n", commondirout);  
  printf ("************\n");
  strcpy (filefich, "cd ");
  strcat (filefich, nomdir);
  erreur = system (filefich);
  if (erreur)
    {
      strcpy (filefich, "mkdir ");
      strcat (filefich, nomdir);
      system (filefich);
      printf ("%s: Directory created\n", nomdir);
    }
  nullify = associate ("nullify_agrif.h");
  griddata = associate ("modgrid_agrif.h");
  typedata = associate ("modtype_agrif.h");
  initproc = associate ("initialisations_agrif.h");
  deallocprocbefore = associate ("deallocations_agrif_before.h");
  deallocprocafter = associate ("deallocations_agrif_after.h");
  instanceproc = associate ("instance_agrif.h");
  inclproc = associate ("include_agrif.h");
  interproc = associate ("interpolation_agrif.h");
  update = associate ("update_agrif.h");
  savelevel = associate ("savelevel_agrif.h");
  copylevel = associate ("copylevel_agrif.h");
  util = associate ("util_agrif.h");
  oldlevel = associate ("oldlevel_agrif.h");
  keys = associate ("keys_agrif.h");
  clustering = associate ("clustering_agrif.h");
  freerestore = associate("free_restore_agrif.h");
  allocrestore = associate("allocate_restore_agrif.h");


/*File modtypes_agrif.h : writing of the space and time refinement factors */

  comment (typedata,
	   "     **************************************************************************");
  comment (typedata,
	   "     AGRIF_coeffrefx : space refinement factor in the x-direction");
  comment (typedata,
	   "     **************************************************************************");
  if (coeffrafx == 0) coeffrafx = 1;
  sprintf (ligne, "Integer, Parameter :: AGRIF_coeffrefx = %d", coeffrafx);
  tofich (typedata, ligne);
  comment (typedata, " ");
  comment (typedata, " ");
  comment (typedata,
	   "     **************************************************************************");
  comment (typedata,
	   "     AGRIF_coeffrefy : space refinement factor in the y-direction");
  comment (typedata,
	   "     **************************************************************************");
  if (coeffrafy == 0) coeffrafy = 1;
  sprintf (ligne, "Integer, Parameter :: AGRIF_coeffrefy = %d", coeffrafy);
  tofich (typedata, ligne);
  comment (typedata, " ");
  comment (typedata, " ");
  comment (typedata,
	   "     **************************************************************************");
  comment (typedata,
	   "     AGRIF_coeffrefz : space refinement factor in the z-direction");
  comment (typedata,
	   "     **************************************************************************");
  if (coeffrafz == 0) coeffrafz = 1;
  sprintf (ligne, "Integer, Parameter :: AGRIF_coeffrefz = %d", coeffrafz);
  tofich (typedata, ligne);
  comment (typedata, " ");
  comment (typedata, " ");
  comment (typedata,
	   "     **************************************************************************");
  comment (typedata,
	   "     AGRIF_coeffreftx : time refinement factor in the x-direction");
  comment (typedata,
	   "     **************************************************************************");
  sprintf (ligne, "Integer, Parameter :: AGRIF_coeffreftx = %d", coeffraftx);
  tofich (typedata, ligne);
  comment (typedata, " ");
  comment (typedata, " ");
  comment (typedata,
	   "     **************************************************************************");
  comment (typedata,
	   "     AGRIF_coeffrefty : time refinement factor in the y-direction");
  comment (typedata,
	   "     **************************************************************************");
  sprintf (ligne, "Integer, Parameter :: AGRIF_coeffrefty = %d", coeffrafty);
  tofich (typedata, ligne);
  comment (typedata, " ");
  comment (typedata, " ");
  comment (typedata,
	   "     **************************************************************************");
  comment (typedata,
	   "     AGRIF_coeffreftz : time refinement factor in the z-direction");
  comment (typedata,
	   "     **************************************************************************");
  sprintf (ligne, "Integer, Parameter :: AGRIF_coeffreftz = %d", coeffraftz);
  tofich (typedata, ligne);
  comment (typedata, " ");
  comment (typedata, " ");
  comment (typedata,
	   "     **************************************************************************");
  comment (typedata,
	   "     AGRIF_NbVariables : number of variables");
  comment (typedata,
	   "     **************************************************************************");
  
  cpt = 0;
  newvar = globliste;
  while (newvar)
  { 
      if (newvar->var->common == 1)
      {
	cpt ++;  
        }   
   
   	newvar = newvar->suiv;
  }
  sprintf (ligne, "Integer, Parameter :: AGRIF_NbVariables = %d",cpt);
  tofich(typedata,ligne);
   



/* File probdim_agrif.h : writing of the dimension of the probleme */

  probdim = associate ("probdim_agrif.h");
  sprintf (ligne, "Integer, Parameter :: Agrif_Probdim = %d", dimprob);
  tofich (probdim, ligne);
 
 fclose (probdim);

/* File keys_agrif.h */
 if (fixedgrids == 1) {
 fprintf(keys,"#define AGRIF_USE_FIXED_GRIDS\n");
 }  
  if (onlyfixedgrids == 1) {
 fprintf(keys,"#define AGRIF_USE_ONLY_FIXED_GRIDS\n");
 }  
  if (dimprob == 1) {
  fprintf(keys,"#define Agrif_Probdim_1D\n");
  }
  else if (dimprob==2) {
  fprintf(keys,"#define Agrif_Probdim_2D\n");}
  else if (dimprob==3) {
  fprintf(keys,"#define Agrif_Probdim_3D\n"); }  

   

/* File parents_agrif.h */

   parentvar = associate ("parents_agrif.h");
   newvar = globliste;
   while (newvar)
   {
     
     v = newvar->var;	
   
     if ((v->toparent) || (v->bc) || (v->tointerp))
     {
        if (v->nbdim == 0) {
         sprintf (ligne, "%s,Pointer :: AGRIF_Parent_%s",v->typevar,v->nomvar);    
         tofich (parentvar,ligne);
	}
     	else if (v->nbdim == 1) {
         sprintf (ligne, "%s,Dimension(:),Pointer :: AGRIF_Parent_%s",v->typevar,v->nomvar);    
         tofich (parentvar,ligne);
	}
	else if (v->nbdim == 2) {
		sprintf (ligne, "%s,Dimension(:,:),Pointer :: AGRIF_Parent_%s",v->typevar,v->nomvar);    
         	tofich (parentvar,ligne);
	}
	else if (v->nbdim == 3) {
		sprintf (ligne, "%s,Dimension(:,:,:),Pointer :: AGRIF_Parent_%s",v->typevar,v->nomvar);    
         	tofich (parentvar,ligne);
	}
	else if (v->nbdim == 4) {
		sprintf (ligne, "%s,Dimension(:,:,:,:),Pointer :: AGRIF_Parent_%s",v->typevar,v->nomvar);    
         	tofich (parentvar,ligne);
	}
	else if (v->nbdim == 5) {
		sprintf (ligne, "%s,Dimension(:,:,:,:,:),Pointer :: AGRIF_Parent_%s",v->typevar,v->nomvar);    
         	tofich (parentvar,ligne);
	}	 
     }	    
   
     newvar = newvar->suiv;
   }
   fclose(parentvar);   


/* File instance_parents_agrif.h */
   
   instanceparents = associate ("instance_parents_agrif.h");

   sprintf(ligne,"If (Agrif_Curgrid %% fixedrank .NE. 0) Then");
   tofich(instanceparents,ligne);

   newvar = globliste;
   while(newvar)
   {
   
   	v = newvar->var;
   		
	
   	if ((v->toparent) || (v->bc) || (v->tointerp))
	{
		    strcpy(ligne,"Agrif_Parent_");
		    strcat(ligne,v->nomvar);
		    strcat(ligne," => Agrif_Curgrid % parent % ");
		    strcat(ligne,varcommonname(v));
		    strcat(ligne,"%var");
		    strcat(ligne,vararrayname(v));       			    
		
		tofich(instanceparents,ligne);
		
	}	
	
	newvar = newvar->suiv;	   
   }

   sprintf(ligne,"End If");
   tofich(instanceparents,ligne);

   fclose (instanceparents);



/* File createvarlist_agrif.h */

  createvarlist = associate ("createvarlist_agrif.h");
  
  newvar = globliste;
  
  i = 1; 
  
  while (newvar)
  {
     v = newvar->var;
     if (v->common == 1)
     {
     strcpy(temp1, basevariablename(v));
/*     sprintf(ligne, "AGRIF_GR %% tabvars(%d) = %s",i,temp1); */
     sprintf(ligne, "%s %% var => AGRIF_GR %% tabvars(%d) %% var",temp1,i);
     tofich(createvarlist,ligne);
     
     i++;
     }	
  
     newvar = newvar->suiv; 
  }
  
  fclose(createvarlist);    


/* File createvarname_agrif.h */

  createvarname = associate ("createvarname_agrif.h");
  
  newvar = globliste;
  
  i = 1;
  
  while(newvar)
  {
     v = newvar->var;
     if (v->common == 1)
     {
     strcpy (temp1,variablename(v));
     
     sprintf(ligne, "%s %% namevar = \"%s\"",temp1,v->nomvar);
     
     	 
     tofich(createvarname,ligne);
     
          i++;
     }
     
	
  
     newvar = newvar->suiv; 
  }  
  
  fclose (createvarname); 
  
  
  
/* Files createvar_agrif.h and createvar_alloc_agrif.h : allocation of memory */
   
  nbvariablesparalloc = max(cpt/15+1,5);
  tempfile=associate("createvar_alloc_interface_agrif.h");
  nbvarcur = 0;
  numerocourant = 1;
  create_v1 = associate ("createvar_alloc_agrif.h");
  createvaralloccalls = associate("createvar_alloc_calls_agrif.h");
  sprintf(ligne,"Subroutine Alloc_Var_Agrif%d(Agrif_Gr)",numerocourant);
  tofich(create_v1,ligne); 
  tofich(tempfile,ligne);
  strcpy(ligne,"Use Agrif_Types, Only : Agrif_grid");
  tofich(create_v1,ligne);
  tofich(tempfile,ligne);
  strcpy(ligne,"Type(Agrif_Grid), Pointer :: Agrif_Gr");
  tofich(create_v1,ligne);
  tofich(tempfile,ligne);
  sprintf(ligne,"Include \"%s\"",commonfile_main);
  tofich(create_v1,ligne);
  sprintf(ligne,"Call Alloc_Var_Agrif%d(Agrif_Gr)",numerocourant);
  tofich(createvaralloccalls,ligne);

  create_v = associate ("createvar_agrif.h");
  comment (create_v, " ");
  strcpy (ligne, "If (Agrif_Gr % fixedrank .NE. 0) then");
  tofich (create_v, ligne);
  comment (create_v, " ");
  newvar = globliste;
  while (newvar)
    {
      v = newvar->var;
      if (v->common == 1)
	{
	nbvarcur = nbvarcur + 1;
        if (nbvarcur >= nbvariablesparalloc && numerocourant < 15)
        {
	strcpy(ligne,"Return");
  tofich(create_v1,ligne);
	sprintf(ligne,"End Subroutine Alloc_Var_Agrif%d",numerocourant);
  tofich(create_v1,ligne);
  tofich(tempfile,ligne);
        numerocourant = numerocourant + 1;
  sprintf(ligne,"Subroutine Alloc_Var_Agrif%d(Agrif_Gr)",numerocourant);
  tofich(create_v1,ligne);
  tofich(tempfile,ligne);
  strcpy(ligne,"Use Agrif_Types, Only : Agrif_grid");
  tofich(create_v1,ligne);
  tofich(tempfile,ligne);
  strcpy(ligne,"Type(Agrif_Grid), Pointer :: Agrif_Gr");
  tofich(create_v1,ligne);
  tofich(tempfile,ligne);
  sprintf(ligne,"Include \"%s\"",commonfile_main);
  tofich(create_v1,ligne);
  sprintf(ligne,"Call Alloc_Var_Agrif%d(Agrif_Gr)",numerocourant);
  tofich(createvaralloccalls,ligne);
        nbvarcur = 0;       
        }
	  strcpy (temp1, variablename (v));
	  strcpy (temp2, variablenameparent (v));
	  strcpy (temp3, variablename (v));
	  strcpy (temp4, variablenameroot (v));
	  sprintf (ligne, "Allocate(%s)", temp1);
	  tofich (create_v1, ligne);
	  if (v->torestaure || v->bc || v->tointerp || v->toupdate) {
	  sprintf (ligne, "%s %% root_var => %s", temp3, temp4);
	  tofich (create_v, ligne);
	  sprintf (ligne, "%s %% nbdim  = %s %% nbdim", temp1, temp2);
	  tofich (create_v, ligne);
	  
	  comment (create_v, " ");}
	  	  
	  strcpy (temp3, basevariablename (v));
	  strcpy (temp4, basevariablenameparent (v));
	  sprintf (ligne, "%s %% parent_var => %s", temp3, temp4);
	  tofich (create_v, ligne);
	  comment (create_v, " ");
/*	  strcpy (ligne, "  Else");
	  tofich (create_v, ligne);
	  comment (create_v, " ");
	  sprintf (ligne, "%s %% parent_var => %s", temp3, temp3);
	  tofich (create_v, ligne);
	  comment (create_v, " ");*/
	  comment (create_v, " ");
	  nline (create_v, 0);
	}

      newvar = newvar->suiv;
    }
	strcpy(ligne,"Return");
	tofich(create_v1, ligne);
	sprintf(ligne,"End Subroutine Alloc_Var_Agrif%d",numerocourant);
	tofich(create_v1, ligne);
  tofich(tempfile,ligne);
        fclose(tempfile);
	fclose(createvaralloccalls);
    fclose(create_v1);
    strcpy (ligne, "End If");
    tofich (create_v, ligne);
    comment (create_v, " ");    

    
    
/* File modgrid_agrif.h : restoration of the grid variable */
  
  nline (typedata, 1);

  newvar = globliste;
  restauration = 0;
  
  while (newvar)
    {
      v = newvar->var;
      if (v->common == 1)
	{
	  if (v->torestaure)
	    restauration = 1;
	  printvar (griddata, v);
	}
      newvar = newvar->suiv;
    }




/* File include_agrif.h */

  strcpy (ligne, "include '");
  strcat (ligne, commonfile_main);
  strcat (ligne, "'");
  tofich (inclproc, ligne);




/* File initialisations_agrif.h : initialization of the fields of the root coarse grid */

  l = list_use;

  while (l)
    {
      sprintf (ligne, "%s = .TRUE.", l->nom);
      tofich (initproc, ligne);
      l = l->suiv;
    }
  nline (initproc, 0);
  
  sprintf (ligne, "AGRIF_mygrid %% nbx = %s", nbmaillesX);
  tofich (initproc, ligne);
  if (dimprob > 1)
    {
      sprintf (ligne, "AGRIF_mygrid %% nby = %s", nbmaillesY);
      tofich (initproc, ligne);
    }
  if (dimprob > 2)
    {
      sprintf (ligne, "AGRIF_mygrid %% nbz = %s", nbmaillesZ);
      tofich (initproc, ligne);
    }
  comment (initproc, " ");


  nline (initproc, 0);
  newvar = globliste;
  while (newvar)
    {
      v = newvar->var;
      strcpy (temp1, variablenameroot (v));
      if (v->common == 1)
	{
	  if (v->posvar)
	    {

	      sprintf (ligne, "Allocate(%s %% posvar(%d))", temp1, v->nbdim);
	      tofich (initproc, ligne);
	      for (i = 0; i < v->nbdim; i++)
		{
		  sprintf (ligne, "%s %% posvar(%d) = %d", temp1, i + 1,
			   (v->posvar)[i]);
		  tofich (initproc, ligne);
		}
	      sprintf (ligne, "Allocate(%s %% interptab(%d))", temp1,
		       v->nbdim);
	      tofich (initproc, ligne);
	      i = 0;
	      j = 0;
	      newdim = v->raf;
	      if (newdim)
		{
		  while (newdim)
		    {
		      i = i + 1;
		      if ((strcasecmp ((newdim->dim).last, "x"))
			  && (strcasecmp ((newdim->dim).last, "y"))
			  && (strcasecmp ((newdim->dim).last, "z")))
			{
			  sprintf (ligne, "%s %%interptab(%d)=\"noint\"",
				   temp1, i);
			}
		      else if (!strcasecmp((newdim->dim).last, "x"))
			{
			  sprintf (ligne, "%s %%interptab(%d)=\"%s\"", temp1,
				   i, (newdim->dim).last);
	      tofich (initproc, ligne);					   
		   if (j==0) {
	      sprintf (ligne, "%s %% pointx = %d", temp1, (v->pt)->i);
	      j++;
	           }
		   else if (j==1) {
	      sprintf (ligne, "%s %% pointx = %d", temp1, (v->pt)->j);	
	      j++;	   
		   }
		   else if (j==2) {
	      sprintf (ligne, "%s %% pointx = %d", temp1, (v->pt)->k);
	      j++;		   
		   }				   
			}
		      else if (!strcasecmp((newdim->dim).last, "y"))
			{
			  sprintf (ligne, "%s %%interptab(%d)=\"%s\"", temp1,
				   i, (newdim->dim).last);
	      tofich (initproc, ligne);					   
		   if (j==0) {
	      sprintf (ligne, "%s %% pointy = %d", temp1, (v->pt)->i);
	      j++;
	           }
		   else if (j==1) {
	      sprintf (ligne, "%s %% pointy = %d", temp1, (v->pt)->j);	
	      j++;	   
		   }
		   else if (j==2) {
	      sprintf (ligne, "%s %% pointy = %d", temp1, (v->pt)->k);
	      j++;		   
		   }				   
			}
		      else if (!strcasecmp((newdim->dim).last, "z"))
			{
			  sprintf (ligne, "%s %%interptab(%d)=\"%s\"", temp1,
				   i, (newdim->dim).last);
	      tofich (initproc, ligne);					   
		   if (j==0) {
	      sprintf (ligne, "%s %% pointz = %d", temp1, (v->pt)->i);
	      j++;
	           }
		   else if (j==1) {
	      sprintf (ligne, "%s %% pointz = %d", temp1, (v->pt)->j);	
	      j++;	   
		   }
		   else if (j==2) {
	      sprintf (ligne, "%s %% pointz = %d", temp1, (v->pt)->k);
	      j++;		   
		   }				   
			}						
		      tofich (initproc, ligne);
		      newdim = newdim->suiv;
		    }
		}
	      else
		{
		  for (i = 1; i <= v->nbdim; i++)
		    {
		      if (i == 1)
			{
			  strcpy (temp, "x");
			}
		      else if (i == 2)
			{
			  strcpy (temp, "y");
			}
		      else if (i == 3)
			{
			  strcpy (temp, "z");
			}
		      else
			{
			  strcpy (temp, "noint");
			}
		      sprintf (ligne, "%s %%interptab(%d)=\"%s\"", temp1, i,
			       temp);
		      tofich (initproc, ligne);
		    }
		}

	    }
	  else
	    {
	      /*sprintf(ligne,"AGRIF_mygrid %% %s %% posvar = 0",v->nomvar);
	         tofich(initproc,ligne); */
	    }
	  sprintf (ligne, "%s %% nbdim = %d", temp1, v->nbdim);
	  tofich (initproc, ligne);
	  comment (initproc, " ");

	  nline (initproc, 0);
	}
      newvar = newvar->suiv;
    }
    
    
    
    
/* File allocations_agrif.h : allocation and initialisation of the arrays of values of the grid variables */
/* File nullify_agrif.h : nullifies these arrays */

  nbvariablesparalloc = max(cpt/15+1,5);
  newvar = globliste;
  nbvarcur = 0;
  numerocourant = 1;
  strcpy(ligne,"allocations_agrif.h");
  allocproc = associate (ligne);
  tempfile=associate("allocations_calls_interface_agrif.h");
  strcpy(ligne,"allocations_calls_agrif.h");
  alloccalls = associate(ligne);
  sprintf(ligne,"Subroutine Allocations_agrif%d(Agrif_Gr)",numerocourant);
  tofich(allocproc,ligne); 
  tofich(tempfile,ligne);
  strcpy(ligne,"Use Agrif_Types, Only : Agrif_grid");
  tofich(allocproc,ligne);
  tofich(tempfile,ligne);
  strcpy(ligne,"Type(Agrif_Grid), Pointer :: Agrif_Gr");
  tofich(allocproc,ligne);
  tofich(tempfile,ligne);
  sprintf(ligne,"Include \"%s\"",commonfile_main);
  tofich(allocproc,ligne);
  sprintf(ligne,"Call Allocations_agrif%d(Agrif_Gr)",numerocourant);
  tofich(alloccalls,ligne);

  while (newvar)
    {
      v = newvar->var;
	nbvarcur = nbvarcur + 1;
        if (nbvarcur >= nbvariablesparalloc && numerocourant < 15)
        {
	strcpy(ligne,"Return");
	tofich(allocproc, ligne);
	sprintf(ligne,"End Subroutine Allocations_agrif%d",numerocourant);
	tofich(allocproc,ligne);
  tofich(tempfile,ligne);
        numerocourant = numerocourant + 1;
  sprintf(ligne,"Subroutine Allocations_agrif%d(Agrif_Gr)",numerocourant);
  tofich(allocproc,ligne); 
  tofich(tempfile,ligne);
  strcpy(ligne,"Use Agrif_Types, Only : Agrif_grid");
  tofich(allocproc,ligne);
  tofich(tempfile,ligne);
  strcpy(ligne,"Type(Agrif_Grid), Pointer :: Agrif_Gr");
  tofich(allocproc,ligne);
  tofich(tempfile,ligne);
  sprintf(ligne,"Include \"%s\"",commonfile_main);
  tofich(allocproc,ligne);
  sprintf(ligne,"Call Allocations_agrif%d(Agrif_Gr)",numerocourant);
  tofich(alloccalls,ligne);
        nbvarcur = 0;       
        }
      if (v->common == 1)
	{
	  if (v->dimension >= 0)
	    {
	      strcpy (ligne, "If (.not. associated(");
	      strcat (ligne, vargridname (v));
	      strcat (ligne, ")) then");
	      tofich (allocproc, ligne);
	      comment (allocproc, " ");
	      strcpy (ligne, "    allocate(");
	      strcat (ligne, vargridname (v));
	      strcat (ligne, vargridparam (v));
	      strcat (ligne, ")");
	      tofich (allocproc, ligne);
	      comment (allocproc, " ");
	      if (v->torestaure) {
	      sprintf(ligne,"Allocate(%s%%Restore%dD%s)",variablename(v),v->nbdim,vargridparam(v));
	      tofich(allocrestore,ligne);
	      comment(allocrestore," ");
	      sprintf(ligne,"%s%%Restore%dD = 0",variablename(v),v->nbdim);
	      tofich(allocrestore,ligne);
sprintf(ligne,"Deallocate(%s%%Restore%dD)",variablename(v),v->nbdim);
	      tofich(freerestore,ligne);	      
	      }
	      comment (allocproc, " ");	      
	      strcpy (ligne, "    ");
	      strcat (ligne, vargridname (v));
	      if ((!strcasecmp (v->typevar, "REAL"))
		  || (!strcasecmp (v->typevar, "INTEGER"))
		  || (!strcasecmp (v->typevar, "REAL*8")))
		{
		  strcat (ligne, " = 0");
		}
	      else if (!strcasecmp (v->typevar, "LOGICAL"))
		{
		  strcat (ligne, " = .FALSE.");
		}
	      else if (!strcasecmp (v->typevar, "CHARACTER"))
		{
		  strcat (ligne, " = \" \"");
		}

	      tofich (allocproc, ligne);
	      comment (allocproc, " ");
	      strcpy (ligne, "End if");
	      tofich (allocproc, ligne);
	      comment (allocproc, " ");
		
	      strcpy (ligne, "Nullify (");
	      strcat (ligne, vargridname (v));
	      strcat (ligne, ")");
	      tofich (nullify, ligne);
	      if (v->tointerp == 1) {
	      sprintf(ligne,"Nullify(%s%%Restore%dD)",variablename(v),v->nbdim);
	      tofich (nullify, ligne); }
	      
/*    strcpy(ligne,v->nomvar);
      strcat(ligne," => ");
      strcat(ligne,vargridname(v));
      tofich(instanceproc,ligne);*/

	    }

	  if (v->bc)
	    {
	      strcpy (lignetemp, vargridname (v));
	      strcpy (ligne, "If (AGRIF_GR % fixedrank .NE. 0) then");
	      tofich (allocproc, ligne);

	      comment (allocproc, " ");
	      strcpy (temp1, variablename (v));
	      sprintf (ligne, "    allocate(%s %% interpIndex)", temp1);
	      tofich (allocproc, ligne);
	      sprintf(ligne, "%s %% interpIndex = -1",temp1);
	      tofich(allocproc,ligne);
	      sprintf(ligne, "Allocate(%s %% oldvalues2D(1,2))",temp1);
	      tofich(allocproc,ligne);
	      sprintf(ligne, "%s %% oldvalues2D = 0. ",temp1);
	      tofich(allocproc,ligne);	      
	      comment (allocproc, " ");

	      strcpy (ligne, "END IF");
	      tofich (allocproc, ligne);

	      comment (allocproc, " ");
	    }
	}
      newvar = newvar->suiv;
    }

	strcpy(ligne,"Return");
	tofich(allocproc, ligne);
	sprintf(ligne,"End Subroutine Allocations_agrif%d",numerocourant);
	tofich(allocproc,ligne);
  tofich(tempfile,ligne);
	fclose(tempfile);
	fclose(alloccalls);

    
/* Files instance_commons_agrif.h and instance_agrif.h */

  filecommon = associate ("instance_commons_agrif.h");

  /* put in globcommons the variables realy in common */
  /* remember that at this stage all the variables are in globcommon*/

  globcommons=NULL;
  newvar = globliste;
  while (newvar)
    {
      v = newvar->var;
      if (v->common == 1) 
	      {
      insertcommon (v, v->commonname);
}
      newvar = newvar->suiv;
    }
    
  commonliste = globcommons;
  tempfile=associate("instance_interface_agrif.h");
  while (commonliste)
    {
      nomcommon = (commonliste->curcommon)->name;
      sprintf (ligne, "Subroutine Agrif_Instance_%s(Agrif_Gr)", nomcommon);
      tofich (filecommon, ligne);
      tofich(tempfile,ligne);
      nline (filecommon, 1);
      strcpy(ligne,"Use Agrif_Types, Only : Agrif_Grid");
      tofich(filecommon, ligne);
      tofich(tempfile,ligne);

      newvar = (commonliste->curcommon)->lvar;
      strcpy (ligne, "Include '");
      strcat (ligne, commonfile_main);
      strcat (ligne, "'");
      tofich (filecommon, ligne);
      sprintf (ligne, "Include '%s'", (newvar->var)->commoninfile);
      tofich (filecommon, ligne);
      nline (filecommon, 1);
      strcpy (ligne, "Type(Agrif_grid), Pointer :: Agrif_Gr");
      tofich (filecommon, ligne);
      tofich(tempfile,ligne);
      nline (filecommon, 1);      

      while (newvar)
	{

	  v = newvar->var;
	  if (strcasecmp (v->typevar, "character")
	      && (v->nbdim >= (mindimstatic + 1)) && (v->staticvar == 0))
	    {
	      strcpy (ligne, v->nomvar);
	      strcat (ligne, " => ");
	      strcat (ligne, vargridname (v));
	      tofich (filecommon, ligne);
	    }
	  else
	    {
	      strcpy (ligne, v->nomvar);
	      strcat (ligne, " = ");
	      strcat (ligne, vargridname (v));
	      tofich (filecommon, ligne);
	    }
	  newvar = newvar->suiv;
	}
      nline (filecommon, 1);
      strcpy (ligne, "Return");
      tofich (filecommon, ligne);
      nline (filecommon, 1);
      sprintf (ligne, "End Subroutine Agrif_Instance_%s", nomcommon);
      tofich (filecommon, ligne);
      tofich(tempfile,ligne);
      nline (filecommon, 2);

      sprintf (ligne, "Call Agrif_Instance_%s(Agrif_Gr)", nomcommon);
      tofich (instanceproc, ligne);

      commonliste = commonliste->suiv;
    }
  fclose (filecommon);
  
  
  
  
/* Files instance_agrif.h and instance_base_agrif.h */
  
  instancebaseproc = associate ("instance_base_agrif.h");
  comment (instanceproc, " ");
  tofich (instanceproc, "Agrif_Curgrid => Agrif_Gr");
  tofich (instancebaseproc, "Agrif_Curgrid => Agrif_Gr");
  comment (instanceproc, " ");
  comment (instancebaseproc, " ");
  strcpy (ligne, "");
  strcat (ligne, nbmaillesX);
  strcat (ligne, "  = Agrif_Gr % nbx");
  tofich (instanceproc, ligne);
  tofich (instancebaseproc, ligne);
  if (dimprob > 1)
    {
      strcpy (ligne, "");
      strcat (ligne, nbmaillesY);
      strcat (ligne, "  = Agrif_Gr % nby");
      tofich (instanceproc, ligne);
      tofich (instancebaseproc, ligne);
    }
  if (dimprob > 2)
    {
      strcpy (ligne, "");
      strcat (ligne, nbmaillesZ);
      strcat (ligne, " = Agrif_Gr % nbz");
      tofich (instanceproc, ligne);
      tofich (instancebaseproc, ligne);
    } 
    
  fclose (instancebaseproc);



  
/* Files back_instance_commons_agrif.h and back_instance_agrif.h */

  filecommon = associate ("back_instance_commons_agrif.h");
  backinstance=associate("back_instance_agrif.h");
  commonliste = globcommons;

  fclose(tempfile);
  tempfile=associate("back_instance_interface_agrif.h");
  while (commonliste)
    {
      nomcommon = (commonliste->curcommon)->name;
	backopen = 0;
      
      newvar = (commonliste->curcommon)->lvar;
      while (newvar)
	{

	  v = newvar->var;
	  if (!(strcasecmp (v->typevar, "character")
	      && (v->nbdim >= (mindimstatic + 1)) && (v->staticvar == 0)))
	  {
	  if (backopen == 0)
	   {
      sprintf (ligne, "Subroutine Agrif_BInstance_%s(Agrif_Gr)", nomcommon);
      tofich (filecommon, ligne);
      tofich(tempfile,ligne);
      nline (filecommon, 1);
      strcpy(ligne,"Use Agrif_Types, Only: Agrif_grid");
      tofich(filecommon,ligne);
      tofich(tempfile,ligne);

      strcpy (ligne, "Include '");
      strcat (ligne, commonfile_main);
      strcat (ligne, "'");
      tofich (filecommon, ligne);
      sprintf (ligne, "Include '%s'", (newvar->var)->commoninfile);
      tofich (filecommon, ligne);
      nline (filecommon, 1);

      strcpy (ligne, "Type(Agrif_grid), Pointer :: Agrif_Gr");
      tofich (filecommon, ligne);
      tofich(tempfile,ligne);
      nline (filecommon, 1);
	backopen = 1;
	   }
	      strcpy (ligne, vargridname (v));		  
	      strcat (ligne, " = ");
	      strcat (ligne, v->nomvar);
	      tofich (filecommon, ligne);
	    }	
	  newvar = newvar->suiv;
	}
      if (backopen == 1)
	{
      nline (filecommon, 1);
      strcpy (ligne, "Return");
      tofich (filecommon, ligne);
      nline (filecommon, 1);
      sprintf (ligne, "End Subroutine Agrif_Binstance_%s", nomcommon);
      tofich(tempfile,ligne);
      tofich (filecommon, ligne);
      nline (filecommon, 2);

      sprintf (ligne, "Call Agrif_Binstance_%s(Agrif_Gr)", nomcommon);
      tofich (backinstance, ligne);
	}

      commonliste = commonliste->suiv;
    }
  fclose (filecommon);
  fclose(backinstance);     
  
  
  
  
/* File deallocations_agrif_before.h : deallocations */

  newvar = globliste;
  while (newvar)
    {
      v = newvar->var;
      if (v->torestaure == 0)
      {
      strcpy (temp1, variablename (v));
      if (v->common == 1)
	{
/*	  if (v->dimension)
	    {*/
	      strcpy (ligne, "If (associated(");
	      strcat (ligne, vargridname(v));
	      strcat (ligne, ")) then");
	      tofich (deallocprocbefore, ligne);
	      comment (deallocprocbefore, " ");
	      strcpy (ligne, "    Deallocate(");
	      strcat (ligne, vargridname (v));
	      strcat (ligne, ")");
	      tofich (deallocprocbefore, ligne);
	      comment (deallocprocbefore, " ");
	      strcpy (ligne, "End if");
	      tofich (deallocprocbefore, ligne);
	      comment (deallocprocbefore, " ");
	      if (coeffraftx != 1 || coeffrafty != 1 || coeffraftz != 1)
		{
		  if (v->bc)
		    {
		      sprintf (ligne, "Deallocate(%s %% oldvalues2D)",
				   temp1);
		      tofich (deallocprocbefore, ligne);
		      
		      sprintf (ligne, "Deallocate(%s %% interpIndex)",
				   temp1);
		      tofich (deallocprocbefore, ligne);		      
		    }
		}
	      sprintf (ligne, "Deallocate(%s)", temp1);
	      tofich (deallocprocbefore, ligne);
/*	    }*/
	}
	}
      newvar = newvar->suiv;
    }
  
/* File deallocations_agrif_after.h : deallocations */

  newvar = globliste;
  while (newvar)
    {
      v = newvar->var;
      if (v->torestaure == 1)
      {      
      strcpy (temp1, variablename (v));
      if (v->common == 1)
	{
	  if (v->dimension)
	    {
	      strcpy (ligne, "If (associated(");
	      strcat (ligne, vargridname (v));
	      strcat (ligne, ")) then");
	      tofich (deallocprocafter, ligne);
	      comment (deallocprocafter, " ");
	      strcpy (ligne, "    Deallocate(");
	      strcat (ligne, vargridname (v));
	      strcat (ligne, ")");
	      tofich (deallocprocafter, ligne);
	      comment (deallocprocafter, " ");
	      strcpy (ligne, "End if");
	      tofich (deallocprocafter, ligne);
	      comment (deallocprocafter, " ");
	      if (coeffraftx != 1 || coeffrafty != 1 || coeffraftz != 1)
		{
		  if (v->bc)
		    {
		      sprintf (ligne, "Deallocate(%s %% oldvalues2D)",
				   temp1);
		      tofich (deallocprocafter, ligne);
		      
		      sprintf (ligne, "Deallocate(%s %% interpIndex)",
				   temp1);
		      tofich (deallocprocafter, ligne);		      
		    }
		}
	      sprintf (ligne, "Deallocate(%s)", temp1);
	      tofich (deallocprocafter, ligne);
	    }
	}
	}
      newvar = newvar->suiv;
    }  
  
  
    
/* Files update_agrif.h and util_agrif.h : writing of the procedures of interpolation, 
   calculation of boundary conditions and update */
  
  newvar = globliste;
  while (newvar)
    {
      v = newvar->var;

      if (v->toupdate == 1)
	{
	  if (!strcasecmp (v->typeupdate, "copy"))
	    {
	      strcpy (v->typeupdate, "Agrif_Update_Copy");
	    }
	  if (!strcasecmp (v->typeupdate, "average"))
	    {
	      strcpy (v->typeupdate, "Agrif_Update_Average");
	    }
	  if (!strcasecmp (v->typeupdate, "full_weighting"))
	    {
	      strcpy (v->typeupdate, "Agrif_Update_Full_Weighting");
	    }	    
	  if (!strcasecmp (v->typeupdate, "user_update"))
	    {
	      strcpy (v->typeupdate, "Agrif_user_update");
	    }

	      strcpy(temp1,curvargridname(v));
	      sprintf (ligne, "Subroutine Agrif_Update_%s(q)",v->nomvar);
	      tofich (update, ligne);
	      sprintf (ligne, "Use Agrif_Update");
	      tofich (update, ligne);
              nline(update,1);
	if (v->nbdim == 1) {
	      sprintf (ligne,
		       "Real, Dimension(lbound(%s,1):ubound(%s,1))::q",
		      temp1,temp1);
      }	      
	      else if (v->nbdim == 2) {
	      sprintf (ligne,
		       "Real, Dimension(lbound(%s,1):ubound(%s,1),lbound(%s,2):ubound(%s,2))::q",
		      temp1,temp1,temp1,temp1);
      }
             else if (v->nbdim == 3) {
	      sprintf (ligne,
		       "Real,  Dimension(lbound(%s,1):ubound(%s,1),lbound(%s,2):ubound(%s,2),lbound(%s,3):ubound(%s,3))::q",
		       temp1,temp1,temp1,temp1,temp1,temp1);
	     }
             else if (v->nbdim == 4) {
	      sprintf (ligne,
		       "Real, Dimension(lbound(%s,1):ubound(%s,1),lbound(%s,2):ubound(%s,2),lbound(%s,3):ubound(%s,3),lbound(%s,4):ubound(%s,4))::q",
		       temp1,temp1,temp1,temp1,temp1,temp1,temp1,temp1);
	     }
             else if (v->nbdim == 5) {
	      sprintf (ligne,
		       "Real, Dimension(lbound(%s,1):ubound(%s,1),lbound(%s,2):ubound(%s,2),lbound(%s,3):ubound(%s,3),lbound(%s,4):ubound(%s,4),lbound(%s,5):ubound(%s,5))::q",
		       temp1,temp1,temp1,temp1,temp1,temp1,temp1,temp1,temp1,temp1);
	     }	     
	      tofich (update, ligne);
	      nline (update, 1);
	      strcpy (ligne, "If (Agrif_Root()) Return");
	      tofich (update, ligne);
	      sprintf (ligne,
		       "Call Agrif_Update_%dD(%s,%s,%s,q)",v->nbdim,
		       v->typeupdate, curbasevariablenameparent(v), curbasevariablename(v));

	      tofich (update, ligne);
	      nline (update, 1);
              strcpy(ligne,"Return");
	      tofich(update,ligne);

	      sprintf (ligne, "End Subroutine Agrif_Update_%s", v->nomvar);
	      tofich (update, ligne);	      
	      nline (update, 2);
	}
	
      if (v->tointerp == 1) {
	      strcpy(temp1,curvargridname(v));
	      if (v->torestaure == 0) {
	      sprintf (ligne, "Subroutine Agrif_Interp_%s(q)",
		       v->nomvar);}
		       
		       else {
	      sprintf (ligne, "Subroutine Agrif_Interp_%s(q,torestore)",
		       v->nomvar);		       
		       }
	      tofich (util, ligne);
	      sprintf (ligne, "Use Agrif_Interpolation");
	      tofich (util, ligne);
              nline(util,1);
	if (v->nbdim == 1) {
	      sprintf (ligne,
		       "Real, Dimension(lbound(%s,1):ubound(%s,1))::q",
		      temp1,temp1);
      }	      
	      else if (v->nbdim == 2) {
	      sprintf (ligne,
		       "Real, Dimension(lbound(%s,1):ubound(%s,1),lbound(%s,2):ubound(%s,2))::q",
		      temp1,temp1,temp1,temp1);
      }
             else if (v->nbdim == 3) {
	      sprintf (ligne,
		       "Real,  Dimension(lbound(%s,1):ubound(%s,1),lbound(%s,2):ubound(%s,2),lbound(%s,3):ubound(%s,3))::q",
		       temp1,temp1,temp1,temp1,temp1,temp1);
	     }
             else if (v->nbdim == 4) {
	      sprintf (ligne,
		       "Real, Dimension(lbound(%s,1):ubound(%s,1),lbound(%s,2):ubound(%s,2),lbound(%s,3):ubound(%s,3),lbound(%s,4):ubound(%s,4))::q",
		       temp1,temp1,temp1,temp1,temp1,temp1,temp1,temp1);
	     }
             else if (v->nbdim == 5) {
	      sprintf (ligne,
		       "Real, Dimension(lbound(%s,1):ubound(%s,1),lbound(%s,2):ubound(%s,2),lbound(%s,3):ubound(%s,3),lbound(%s,4):ubound(%s,4),lbound(%s,5):ubound(%s,5))::q",
		       temp1,temp1,temp1,temp1,temp1,temp1,temp1,temp1,temp1,temp1);
	     }	     
	      tofich (util, ligne);
	      if (v->torestaure == 1)
	      {
	      strcpy(ligne,"Logical :: torestore");
	      tofich(util,ligne);
	      }
	      nline (util, 1);
	      strcpy (ligne, "If (Agrif_Root()) Return");
	      tofich (util, ligne);
	      if (v->torestaure == 0) {
	      sprintf (ligne,
		       "Call Agrif_Interp_%dD(%s,%s,%s,q,.FALSE.)",v->nbdim,
		       v->typeinterp, curbasevariablenameparent(v), curbasevariablename(v)); }
		       else {
	      sprintf (ligne,
		       "Call Agrif_Interp_%dD(%s,%s,%s,q,torestore)",v->nbdim,
		       v->typeinterp, curbasevariablenameparent(v), curbasevariablename(v));		       
		       }
	      tofich (util, ligne);
	      nline (util, 1);
              strcpy(ligne,"Return");
	      tofich(util,ligne);

	      sprintf (ligne, "End Subroutine Agrif_Interp_%s", v->nomvar);
	      tofich (util, ligne);	      
	      nline (util, 2);
      }
      
      if (v->bc)
	{
		strcpy(temp1,curvargridname(v));
          
	  if (v->nbdim == 1)
	    {
	      sprintf (ligne, "Subroutine Agrif_Bc_%s(q,weight,pweight)",
		       v->nomvar);
	      tofich (util, ligne);
	      strcpy (ligne, "Use Agrif_Boundary");
	      tofich (util, ligne);
	      sprintf (ligne,
		       "Real, Dimension(lbound(%s,1):ubound(%s,1))::q",
		       temp1,temp1,temp1,temp1);
	      tofich (util, ligne);
	      strcpy (ligne, "Real ::weight");
	      tofich (util, ligne);
	      strcpy (ligne, "Logical ::pweight");
	      tofich (util, ligne);
	      nline (util, 1);
	      strcpy (ligne, "If (Agrif_Root()) Return");
	      tofich (util, ligne);
	      sprintf (ligne,
		       "Call Agrif_interp_bc_1D(%s,%s,%s,q,%d,%d,weight,pweight)",
		       v->typeinterpbc, curbasevariablenameparent(v), curbasevariablename(v), (v->bc)->i,
		       (v->bc)->j);
	      tofich (util, ligne);
	      sprintf (ligne, "End Subroutine Agrif_Bc_%s", v->nomvar);
	      tofich (util, ligne);
	    }
	  					
	  else if (v->nbdim == 2)
	    {
	      sprintf (ligne, "Subroutine Agrif_Bc_%s(q,weight,pweight)",
		       v->nomvar);
	      tofich (util, ligne);
	      strcpy (ligne, "Use Agrif_Boundary");
	      tofich (util, ligne);
	      sprintf (ligne,
		       "Real, Dimension(lbound(%s,1):ubound(%s,1),lbound(%s,2):ubound(%s,2))::q",
		       temp1,temp1,temp1,temp1);
	      tofich (util, ligne);
	      strcpy (ligne, "Real ::weight");
	      tofich (util, ligne);
	      strcpy (ligne, "Logical ::pweight");
	      tofich (util, ligne);
	      nline (util, 1);
	      strcpy (ligne, "If (Agrif_Root()) RETURN");
	      tofich (util, ligne);
	      sprintf (ligne,
		       "Call Agrif_Interp_Bc_2D(%s,%s,%s,q,%d,%d,weight,pweight)",
		       v->typeinterpbc, curbasevariablenameparent(v), curbasevariablename(v), (v->bc)->i,
		       (v->bc)->j);
	      tofich (util, ligne);
	      sprintf (ligne, "End Subroutine Agrif_Bc_%s", v->nomvar);
	      tofich (util, ligne);
	    }


	  else if (v->nbdim == 3)
	    {
	      sprintf (ligne, "Subroutine Agrif_Bc_%s(q,weight,pweight)",
		       v->nomvar);
	      tofich (util, ligne);
	      strcpy (ligne, "Use Agrif_boundary");
	      tofich (util, ligne);
	      sprintf (ligne,
		       "Real, Dimension(lbound(%s,1):ubound(%s,1),lbound(%s,2):ubound(%s,2),lbound(%s,3):ubound(%s,3))::q",
		       temp1,temp1,temp1,temp1,temp1,temp1);
	      tofich (util, ligne);
	      strcpy (ligne, "Real :: weight");
	      tofich (util, ligne);
	      strcpy (ligne, "Logical :: pweight");
	      tofich (util, ligne);
	      nline (util, 1);
	      strcpy (ligne, "If (Agrif_Root()) Return");
	      tofich (util, ligne);
	      sprintf (ligne,
		       "Call Agrif_Interp_Bc_3D(%s,%s,%s,q,%d,%d,weight,pweight)",
		       v->typeinterpbc,curbasevariablenameparent(v), curbasevariablename(v), (v->bc)->i,
		       (v->bc)->j);
	      tofich (util, ligne);
	      sprintf (ligne, "End Subroutine Agrif_Bc_%s", v->nomvar);
	      tofich (util, ligne);
	      nline (util, 2);

	    }
	  else if (v->nbdim == 4)
	    {
	      nline (util, 2);

	      sprintf (ligne,
		       "Subroutine Agrif_Bc_%s(q,weight,pweight)",
		       v->nomvar);
	      tofich (util, ligne);
	      strcpy (ligne, "Use Agrif_Boundary");
	      tofich (util, ligne);
	      sprintf (ligne,"Real, Dimension(lbound(%s,1):ubound(%s,1),lbound(%s,2):ubound(%s,2),lbound(%s,3):ubound(%s,3),lbound(%s,4):ubound(%s,4))::q",
		       temp1, temp1, temp1, temp1, temp1,temp1, temp1, temp1);
	      tofich (util, ligne);
	      strcpy (ligne, "Real :: weight");
	      tofich (util, ligne);
	      strcpy (ligne, "Logical :: pweight");
	      tofich (util, ligne);
	      nline (util, 1);
	      strcpy (ligne, "If (Agrif_Root()) Return");
	      tofich (util, ligne);
	      sprintf (ligne,
		       "Call Agrif_Interp_Bc_4D(%s,%s,%s,q,%d,%d,weight,pweight)",
		       v->typeinterpbc, curbasevariablenameparent(v), curbasevariablename(v), (v->bc)->i,
		       (v->bc)->j);
	      tofich (util, ligne);
	      sprintf (ligne, "End Subroutine Agrif_Bc_%s", v->nomvar);
	      tofich (util, ligne);

	    }

	  else if (v->nbdim == 5)
	    {
	      nline (util, 2);

	      sprintf (ligne,
		       "Subroutine Agrif_Bc_%s(q,weight,pweight)",
		       v->nomvar);
	      tofich (util, ligne);

	      sprintf (ligne, "Use Agrif_Boundary", v->nomvar);
	      tofich (util, ligne);
	      sprintf (ligne,"Real, Dimension(lbound(%s,1):ubound(%s,1),lbound(%s,2):ubound(%s,2),lbound(%s,3):ubound(%s,3),lbound(%s,4):ubound(%s,4),lbound(%s,5):ubound(%s,5))::q",
		       temp1, temp1, temp1, temp1, temp1,temp1, temp1, temp1,temp1,temp1);

	      tofich (util, ligne);
	      strcpy (ligne, "Real :: weight");
	      tofich (util, ligne);
	      strcpy (ligne, "Logical :: pweight");
	      tofich (util, ligne);
	      nline (util, 1);
	      strcpy (ligne, "If (Agrif_Root()) Return");
	      tofich (util, ligne);
	      sprintf (ligne,
		       "Call Agrif_Interp_Bc_5D(%s,%s,%s,q,%d,%d,weight,pweight)",
		       v->typeinterpbc, curbasevariablenameparent(v), curbasevariablename(v), (v->bc)->i,
		       (v->bc)->j);
	      tofich (util, ligne);
	      sprintf (ligne, "End subroutine Agrif_Bc_%s", v->nomvar);
	      tofich (util, ligne);

	    }

	  nline (util, 2);


	}
	
	if ((v->tointerp == 1) && (v->bc))
	{
		if (v->torestaure == 0) {
		sprintf (ligne,"Subroutine Agrif_Init_%s(q)",v->nomvar);
		}
		else
		{
		sprintf (ligne,"Subroutine Agrif_Init_%s(q,torestore)",v->nomvar);		
		}
	  	tofich (util,ligne);
		
		nline (util, 1);

		sprintf (ligne,"Use AGRIF_Boundary");
		tofich (util,ligne);
		
		nline(util,1);
	
		if (v->nbdim == 1) {
	      		sprintf (ligne,
		       		"Real, Dimension(lbound(%s,1):ubound(%s,1))::q",
		      		temp1,temp1);
      				}	      
	      	else if (v->nbdim == 2) {
	      		sprintf (ligne,
		       		"Real, Dimension(lbound(%s,1):ubound(%s,1),lbound(%s,2):ubound(%s,2))::q",
		      		temp1,temp1,temp1,temp1);
      				}
             	else if (v->nbdim == 3) {
	      		sprintf (ligne,
		       		"Real,  Dimension(lbound(%s,1):ubound(%s,1),lbound(%s,2):ubound(%s,2),lbound(%s,3):ubound(%s,3))::q",
		       		temp1,temp1,temp1,temp1,temp1,temp1);
	     			}
             	else if (v->nbdim == 4) {
	      		sprintf (ligne,
		       		"Real, Dimension(lbound(%s,1):ubound(%s,1),lbound(%s,2):ubound(%s,2),lbound(%s,3):ubound(%s,3),lbound(%s,4):ubound(%s,4))::q",
		       		temp1,temp1,temp1,temp1,temp1,temp1,temp1,temp1);
	     			}
             	else if (v->nbdim == 5) {
	      		sprintf (ligne,
		       		"Real, Dimension(lbound(%s,1):ubound(%s,1),lbound(%s,2):ubound(%s,2),lbound(%s,3):ubound(%s,3),lbound(%s,4):ubound(%s,4),lbound(%s,5):ubound(%s,5))::q",
		       		temp1,temp1,temp1,temp1,temp1,temp1,temp1,temp1,temp1,temp1);
	     			}	     
	      	tofich (util, ligne);
	        if (v->torestaure == 1) {
		strcpy(ligne,"Logical :: torestore");
		tofich(util,ligne);
		}
	      	nline (util, 1);
		
		strcpy (ligne, "If (Agrif_Root()) Return");
	   	tofich (util, ligne);
		
		nline (util, 1);
		if (v->torestaure == 0) {
		sprintf (ligne,
		    	"CALL Agrif_Interp_%s(q)",v->nomvar);}
			else
			{
		sprintf (ligne,
		    	"CALL Agrif_Interp_%s(q,torestore)",v->nomvar);			
			}
	      	tofich (util, ligne);
		
		sprintf (ligne,
		     	"CALL Agrif_Bc_%s(q,1.,.true.)",v->nomvar);
	   	tofich (util, ligne);
		
		nline (util, 1);
		
		sprintf (ligne, "End Subroutine Agrif_Init_%s", v->nomvar);
	      	tofich (util, ligne);
		
	}	
		

      newvar = newvar->suiv;
    }


/* *********************  SAUVEGARDE */
/*  savelevel: sauvegarde des tableaux*/
/* et copyfromold: recopie des tableaux sauvegardes*/

cmpt=0;
newvar=globliste;
while (newvar)
      {
      v=newvar->var;
      if (v->torestaure == 1)
      {
        strcpy(temp1,curvargridname(v));

	sprintf(ligne,"Call Agrif_Copy(Agrif_New_Gr,Agrif_Old_Gr,Agrif_New_Gr % %%s,Agrif_Old_Gr%%%s)",varcommonname(v),varcommonname(v));
	tofich(copylevel,ligne);
	nline(copylevel,1);
        }
        newvar=newvar->suiv;
       } 
 
 
  fclose (create_v);
  fclose (util);
  fclose (copylevel);
  fclose (savelevel);
  fclose (interproc);
  fclose (griddata);  
  fclose (typedata);  
  fclose (initproc);
  fclose (deallocprocbefore);  
  fclose (deallocprocafter);
  fclose (instanceproc);  
  fclose (inclproc); 
  fclose (nullify);
  fclose (oldlevel);
  fclose (update);   
  fclose(keys);
  
  sprintf(ligne,"Integer, Parameter :: Agrif_Regridding = %d\n",regridding);
  tofich(clustering,ligne);
  sprintf(ligne,"Integer, Parameter :: Agrif_Minwidth = %d\n",minwidth);
  tofich(clustering,ligne);
  sprintf(ligne,"Real, Parameter :: Agrif_Efficiency = %e\n",(float) (efficiency)/100.);
  tofich(clustering,ligne);
  res=1.;
  for (i=1;i<rafmaxx;i++)
    res=res*(float)coeffrafx;
    if (res == 0.) res=1.;
  sprintf(ligne,"Real, Parameter :: Agrif_mindx = %e\n",1./res);
  tofich(clustering,ligne);
  
  res=1.;
  for (i=1;i<rafmaxy;i++)
    res=res*(float)coeffrafy; 
    if (res == 0.) res=1.;     
  sprintf(ligne,"Real, Parameter :: Agrif_mindy = %e\n",1./res);
  tofich(clustering,ligne);
  
  res=1.;
  for (i=1;i<rafmaxz;i++)  
    res=res*(float)coeffrafz; 
    if (res == 0.) res=1.;    
  sprintf(ligne,"Real, Parameter :: Agrif_mindz = %e\n",1./res);
  tofich(clustering,ligne);
          
  fclose(clustering);
  
/* Files declare_indices_points_agrif.h and indices_points_agrif.h */

  declindicespoints = associate("declare_indices_points_agrif.h"); 
  indicespoints = associate("indices_points_agrif.h"); 
  
   newvar = globliste;
   while (newvar)
   {
     
     v = newvar->var;	
   
     if ((v->bc) || (v->tointerp))
     {
       sprintf(ligne,"Integer :: Agrif_FirstPointx_%s\n",v->nomvar);
       tofich(declindicespoints,ligne);
       sprintf(ligne,"Integer :: Agrif_FirstPointy_%s\n",v->nomvar);
       tofich(declindicespoints,ligne);       
       sprintf(ligne,"Integer :: Agrif_FirstPointz_%s\n",v->nomvar);
       tofich(declindicespoints,ligne);       
       sprintf(ligne,"Integer :: Agrif_LastPointx_%s\n",v->nomvar);
       tofich(declindicespoints,ligne);       
       sprintf(ligne,"Integer :: Agrif_LastPointy_%s\n",v->nomvar);
       tofich(declindicespoints,ligne);       
       sprintf(ligne,"Integer :: Agrif_LastPointz_%s\n",v->nomvar);
       tofich(declindicespoints,ligne);       
     }	    
   
     newvar = newvar->suiv;
   }
     
}
