!
! $Id: def_diags.F,v 1.4 2005/10/10 13:40:17 pmarches Exp $
!
#ifndef AVRH
# include "cppdefs.h"
#endif
#if defined  DIAGNOSTICS_TS || defined DIAGNOSTICS_UV
# ifndef AVRH                  
      subroutine def_diags(ncid,total_rec,ierr) 
# else
      subroutine def_diags_avg(ncid,total_rec,ierr)
# endif
!
!---------------------------------------------------------------
! Create diag data NetCDF file:
! Define its variables, dimensions, and attributes
!---------------------------------------------------------------
!
      implicit none
# include "param.h"
# include "mixing.h"
# include "ncscrum.h"
# include "scalars.h"
# include "strings.h"
# include "netcdf.inc"
      logical create_new_file, res
      integer ncid, total_rec, ierr, rec, lstr,lvar,lenstr, timedim
     &      , r2dgrd(3),u2dgrd(3),v2dgrd(3),auxil(2),checkdims 
# ifdef SOLVE3D
     &      , r3dgrd(4),u3dgrd(4),v3dgrd(4), itrc
# endif
!
# ifndef AVRH
!
#  define ncname dianame
#  define rec_per_file nrpfdia
#  define wrt wrtdia
#  define vidTime diaTime
#  define vidTstep diaTstep
!
#  ifdef DIAGNOSTICS_TS
#   define vidTXadv diaTXadv
#   define vidTYadv diaTYadv
#   define vidTVadv diaTVadv
#   define vidTHmix diaTHmix
#   define vidTVmix diaTVmix
#   define vidTbody diaTbody
#   define vidTrate diaTrate
#  endif
!
#  ifdef DIAGNOSTICS_UV
#   define vidMXadv diaMXadv
#   define vidMYadv diaMYadv
#   define vidMVadv diaMVadv
#   define vidMCor diaMCor
#   define vidMPrsgrd diaMPrsgrd
#   define vidMHmix diaMHmix
#   define vidMVmix diaMVmix
#   define vidMrate diaMrate
#  endif
!
# else /* AVRH */
!
#  define ncname dianame_avg
#  define rec_per_file nrpfdia_avg
#  define wrt wrtdia_avg
#  define vidTime diaTime_avg
#  define vidTstep diaTstep_avg
!
#  ifdef DIAGNOSTICS_TS
#   define vidTXadv diaTXadv_avg
#   define vidTYadv diaTYadv_avg
#   define vidTVadv diaTVadv_avg
#   define vidTHmix diaTHmix_avg
#   define vidTVmix diaTVmix_avg
#   define vidTbody diaTbody_avg
#   define vidTrate diaTrate_avg
#  endif
!
#  ifdef DIAGNOSTICS_UV
#   define vidMXadv diaMXadv_avg
#   define vidMYadv diaMYadv_avg
#   define vidMVadv diaMVadv_avg
#   define vidMCor diaMCor_avg
#   define vidMPrsgrd diaMPrsgrd_avg
#   define vidMHmix diaMHmix_avg
#   define vidMVmix diaMVmix_avg
#   define vidMrate diaMrate_avg
#  endif
!
        character*60 text
!
# endif /* AVRH */
!
      if (may_day_flag.ne.0) return      !-->  EXIT
!
      ierr=0
      lstr=lenstr(ncname)
      if (nrpfdia.gt.0) then
        lvar=total_rec-(1+mod(total_rec-1, nrpfdia))
        call insert_time_index (ncname, lstr, lvar, ierr)
        if (ierr .ne. 0) goto 99
      endif
!
!  Create a new diagnostics data file.
!-------------------------------------
!
#ifndef AVRH
      create_new_file=ldefdia
#else
      create_new_file=ldefdia_avg
#endif
!
      if (ncid.ne.-1) create_new_file=.false.
#if defined MPI & !defined PARALLEL_FILES
      if (mynode.gt.0) create_new_file=.false.
#endif
!
 10   if (create_new_file) then
        lstr=lenstr(ncname)
        ierr=nf_create(ncname(1:lstr),nf_clobber,ncid)
        if (ierr.ne.nf_noerr) then
          write(stdout,11) ncname(1:lstr)
          may_day_flag=3
          return                         !-->  EXIT
        endif
!
! Put global attributes.
! --- ------ -----------
!
        call put_global_atts (ncid, ierr)
        if (ierr.ne.nf_noerr) then
          write(stdout,11) ncname(1:lstr)
          may_day_flag=3
          return                         !-->  EXIT
        endif
!
! Define dimensions of staggered fields.
! ------ ---------- -- --------- -------
!
        ierr=nf_def_dim (ncid, 'xi_rho',   xi_rho,   r2dgrd(1))
        ierr=nf_def_dim (ncid, 'xi_u',     xi_u,     u2dgrd(1))
        ierr=nf_def_dim (ncid, 'eta_rho',  eta_rho,  r2dgrd(2))
        ierr=nf_def_dim (ncid, 'eta_v',    eta_v,    v2dgrd(2))
#ifdef SOLVE3D
        ierr=nf_def_dim (ncid, 's_rho',    N,        r3dgrd(3))
#endif
        ierr=nf_def_dim (ncid, 'time', nf_unlimited, timedim)
        ierr=nf_def_dim (ncid, 'auxil',    4,        auxil(1))
!
        auxil(2)=timedim
        r2dgrd(3)=timedim           ! Free surface
!
        u2dgrd(2)=r2dgrd(2)         ! 2D UBAR-type
        u2dgrd(3)=timedim
!
        v2dgrd(1)=r2dgrd(1)         ! 2D VBAR-type
        v2dgrd(3)=timedim
!
#ifdef SOLVE3D
        r3dgrd(1)=r2dgrd(1)         !
        r3dgrd(2)=r2dgrd(2)         ! 3D RHO-type
        r3dgrd(4)=timedim           !
!
        u3dgrd(1)=u2dgrd(1)         !
        u3dgrd(2)=r2dgrd(2)         ! 3D U-type
        u3dgrd(3)=r3dgrd(3)         !
        u3dgrd(4)=timedim
!
        v3dgrd(1)=r2dgrd(1)         !
        v3dgrd(2)=v2dgrd(2)         ! 3D V-type
        v3dgrd(3)=r3dgrd(3)         !
        v3dgrd(4)=timedim
#endif
!
#if (defined PUT_GRID_INTO_HISTORY && !defined AVRH)\
 || (defined PUT_GRID_INTO_AVERAGES && defined AVRH)
!
! Define grid variables :
! ------ ---- ---------
!
        if (total_rec.le.1) call def_grid (ncid, r2dgrd)
#endif
!
! Define running parameters :
!--------------------------
!
! Define variables (time step number and time record indices)
! and their attributes
!
        ierr=nf_def_var (ncid, 'time_step', nf_int, 2, auxil,
     &                                                 vidTstep)
        ierr=nf_put_att_text (ncid, diaTstep, 'long_name', 48,
     &       'time step and record numbers from initialization')
!
        lvar=lenstr(vname(1,indxTime))
        ierr=nf_def_var (ncid, vname(1,indxTime)(1:lvar),
     &                            NF_FOUT, 1, timedim, vidTime)
!
#ifndef AVRH
        lvar=lenstr(vname(2,indxTime))
        ierr=nf_put_att_text (ncid, vidTime, 'long_name', 
     &       lvar, vname(2,indxTime)(1:lvar))
#else
        text='avg'/ /vname(2,indxTime)
        lvar=lenstr(text)
        ierr=nf_put_att_text (ncid, vidTime, 'long_name', 
     &       lvar, text(1:lvar))
#endif
!
        lvar=lenstr(vname(2,indxTime))
        ierr=nf_put_att_text (ncid, vidTime, 'long_name', lvar,
     &                                vname(2,indxTime)(1:lvar))
!
        lvar=lenstr(vname(3,indxTime))
        ierr=nf_put_att_text (ncid, vidTime, 'units',  lvar,
     &                                vname(3,indxTime)(1:lvar))
!
        lvar=lenstr(vname(4,indxTime))
        ierr=nf_put_att_text (ncid, vidTime, 'field',  lvar,
     &                                vname(4,indxTime)(1:lvar))
!
! Tracer diagnostics variables :
! ------ ----------- ---------
!
#ifdef DIAGNOSTICS_TS
!
        do itrc=1,NT
!
! indxTXadv
!
           lvar=lenstr(vname(1,indxTXadv+itrc-1))
           ierr=nf_def_var (ncid, vname(1,indxTXadv+itrc-1)(1:lvar),
     &                           NF_FOUT, 4, r3dgrd, vidTXadv(itrc))
# ifndef AVRH
           lvar=lenstr(vname(2,indxTXadv+itrc-1))
           ierr=nf_put_att_text (ncid, vidTXadv(itrc), 'long_name',
     &                     lvar, vname(2,indxTXadv+itrc-1)(1:lvar))
# else
           text='averaged '/ /vname(2,indxTXadv+itrc-1)
           lvar=lenstr(text)
           ierr=nf_put_att_text (ncid, vidTXadv(itrc), 'long_name', 
     &       lvar, text(1:lvar))
# endif
           lvar=lenstr(vname(3,indxTXadv+itrc-1))
           ierr=nf_put_att_text (ncid, vidTXadv(itrc), 'units', lvar,
     &                             vname(3,indxTXadv+itrc-1)(1:lvar))
           lvar=lenstr(vname(4,indxTXadv+itrc-1))
           ierr=nf_put_att_text (ncid,vidTXadv(itrc), 'field',
     &                       lvar, vname(4,indxTXadv+itrc-1)(1:lvar))
!
! indxTYadv
!
           lvar=lenstr(vname(1,indxTYadv+itrc-1))
           ierr=nf_def_var (ncid, vname(1,indxTYadv+itrc-1)(1:lvar),
     &                           NF_FOUT, 4, r3dgrd, vidTYadv(itrc))
# ifndef AVRH
           lvar=lenstr(vname(2,indxTYadv+itrc-1))
           ierr=nf_put_att_text (ncid, vidTYadv(itrc), 'long_name',
     &                     lvar, vname(2,indxTYadv+itrc-1)(1:lvar))
# else
           text='averaged '/ /vname(2,indxTYadv+itrc-1)
           lvar=lenstr(text)
           ierr=nf_put_att_text (ncid, vidTYadv(itrc), 'long_name', 
     &       lvar, text(1:lvar))
# endif
           lvar=lenstr(vname(3,indxTYadv+itrc-1))
           ierr=nf_put_att_text (ncid, vidTYadv(itrc), 'units', lvar,
     &                             vname(3,indxTYadv+itrc-1)(1:lvar))
           lvar=lenstr(vname(4,indxTYadv+itrc-1))
           ierr=nf_put_att_text (ncid,vidTYadv(itrc), 'field',
     &                       lvar, vname(4,indxTYadv+itrc-1)(1:lvar))
!
! indxTVadv
!
           lvar=lenstr(vname(1,indxTVadv+itrc-1))
           ierr=nf_def_var (ncid, vname(1,indxTVadv+itrc-1)(1:lvar),
     &                           NF_FOUT, 4, r3dgrd, vidTVadv(itrc))
# ifndef AVRH
           lvar=lenstr(vname(2,indxTVadv+itrc-1))
           ierr=nf_put_att_text (ncid, vidTVadv(itrc), 'long_name',
     &                     lvar, vname(2,indxTVadv+itrc-1)(1:lvar))
# else
           text='averaged '/ /vname(2,indxTVadv+itrc-1)
           lvar=lenstr(text)
           ierr=nf_put_att_text (ncid, vidTVadv(itrc), 'long_name', 
     &       lvar, text(1:lvar))
# endif
           lvar=lenstr(vname(3,indxTVadv+itrc-1))
           ierr=nf_put_att_text (ncid, vidTVadv(itrc), 'units', lvar,
     &                             vname(3,indxTVadv+itrc-1)(1:lvar))
           lvar=lenstr(vname(4,indxTVadv+itrc-1))
           ierr=nf_put_att_text (ncid,vidTVadv(itrc), 'field',
     &                       lvar, vname(4,indxTVadv+itrc-1)(1:lvar))
!
! indxTHmix
!
           lvar=lenstr(vname(1,indxTHmix+itrc-1))
           ierr=nf_def_var (ncid, vname(1,indxTHmix+itrc-1)(1:lvar),
     &                            NF_FOUT, 4, r3dgrd, vidTHmix(itrc))
# ifndef AVRH
           lvar=lenstr(vname(2,indxTHmix+itrc-1))
           ierr=nf_put_att_text (ncid, vidTHmix(itrc), 'long_name',
     &                       lvar, vname(2,indxTHmix+itrc-1)(1:lvar))
# else
           text='averaged '/ /vname(2,indxTHmix+itrc-1)
           lvar=lenstr(text)
           ierr=nf_put_att_text (ncid, vidTHmix(itrc), 'long_name',
     &                                            lvar, text(1:lvar))
# endif
           lvar=lenstr(vname(3,indxTHmix+itrc-1))
           ierr=nf_put_att_text (ncid, diaTHmix(itrc), 'units', lvar,
     &                             vname(3,indxTHmix+itrc-1)(1:lvar))
           lvar=lenstr(vname(4,indxTHmix+itrc-1))
           ierr=nf_put_att_text (ncid,vidTHmix(itrc), 'field',
     &                       lvar, vname(4,indxTHmix+itrc-1)(1:lvar))
!
!indxTVmix
!
           lvar=lenstr(vname(1,indxTVmix+itrc-1))
           ierr=nf_def_var (ncid, vname(1,indxTVmix+itrc-1)(1:lvar),
     &                             NF_FOUT, 4, r3dgrd, vidTVmix(itrc))
# ifndef AVRH
           lvar=lenstr(vname(2,indxTVmix+itrc-1))
           ierr=nf_put_att_text (ncid, vidTVmix(itrc), 'long_name',
     &                     lvar, vname(2,indxTVmix+itrc-1)(1:lvar))
# else
           text='averaged '/ /vname(2,indxTVmix+itrc-1)
           lvar=lenstr(text)
           ierr=nf_put_att_text (ncid, vidTVmix(itrc), 'long_name', 
     &       lvar, text(1:lvar))
# endif
           lvar=lenstr(vname(3,indxTVmix+itrc-1))
           ierr=nf_put_att_text (ncid, diaTVmix(itrc), 'units', lvar,
     &                             vname(3,indxTVmix+itrc-1)(1:lvar))
           lvar=lenstr(vname(4,indxTVmix+itrc-1))
           ierr=nf_put_att_text (ncid,vidTVmix(itrc), 'field',
     &                       lvar, vname(4,indxTVmix+itrc-1)(1:lvar))
!
! indxTbody - Solar radiation and nudging body forces
!
           lvar=lenstr(vname(1,indxTbody+itrc-1))
           ierr=nf_def_var (ncid,vname(1,indxTbody+itrc-1)(1:lvar),
     &                        NF_FOUT, 4, r3dgrd, vidTbody(itrc))
# ifndef AVRH
           lvar=lenstr(vname(2,indxTbody+itrc-1))
           ierr=nf_put_att_text (ncid, vidTbody(itrc), 'long_name', 
     &                      lvar, vname(2,indxTbody+itrc-1)(1:lvar))
# else
           text='averaged '/ /vname(2,indxTbody+itrc-1)
           lvar=lenstr(text)
           ierr=nf_put_att_text (ncid, vidTbody(itrc), 'long_name', 
     &          lvar, text(1:lvar))
# endif
           lvar=lenstr(vname(3,indxTbody+itrc-1))
           ierr=nf_put_att_text (ncid, vidTbody(itrc),'units',     
     &                     lvar, vname(3,indxTbody+itrc-1)(1:lvar))
           lvar=lenstr(vname(4,indxTbody+itrc-1))
           ierr=nf_put_att_text (ncid, vidTbody(itrc),'field',     
     &                     lvar, vname(4,indxTbody+itrc-1)(1:lvar))
!
! Trate indxTrate
!
           lvar=lenstr(vname(1,indxTrate+itrc-1))
           ierr=nf_def_var (ncid, vname(1,indxTrate+itrc-1)(1:lvar),
     &                           NF_FOUT, 4, r3dgrd, vidTrate(itrc))
# ifndef AVRH
           lvar=lenstr(vname(2,indxTrate+itrc-1))
           ierr=nf_put_att_text (ncid, vidTrate(itrc), 'long_name', 
     &                     lvar, vname(2,indxTrate+itrc-1)(1:lvar))
# else
           text='averaged '/ /vname(2,indxTrate+itrc-1)
           lvar=lenstr(text)
           ierr=nf_put_att_text (ncid, vidTrate(itrc), 'long_name', 
     &                                          lvar, text(1:lvar))
# endif
           lvar=lenstr(vname(3,indxTrate+itrc-1))
           ierr=nf_put_att_text (ncid, vidTrate(itrc),'units',
     &                     lvar, vname(3,indxTrate+itrc-1)(1:lvar))
           lvar=lenstr(vname(4,indxTrate+itrc-1))
           ierr=nf_put_att_text (ncid, vidTrate(itrc),'field',
     &                     lvar, vname(4,indxTrate+itrc-1)(1:lvar))
!
        end do
!
#endif /* DIAGNOSTICS_TS */
!
! Momentum diagnostics variables.
! -------- ----------- --------
!
#ifdef DIAGNOSTICS_UV
!
        do itrc=1,2  ! use itrc indice = 1 for u_momentum
!                    !                 = 2 for v_momentum 
!
! indxMXadv
!
          if (itrc.eq.1) then
            r3dgrd=u3dgrd
          else
            r3dgrd=v3dgrd
          endif
!
          lvar=lenstr(vname(1,indxMXadv+itrc-1))
          ierr=nf_def_var (ncid, vname(1,indxMXadv+itrc-1)(1:lvar),
     &                     NF_FOUT, 4, r3dgrd, vidMXadv(itrc))
# ifndef AVRH
          lvar=lenstr(vname(2,indxMXadv+itrc-1))
          ierr=nf_put_att_text (ncid, vidMXadv(itrc), 'long_name',
     &                      lvar, vname(2,indxMXadv+itrc-1)(1:lvar))
# else
          text='averaged '/ /vname(2,indxMXadv+itrc-1)
          lvar=lenstr(text)
          ierr=nf_put_att_text (ncid, vidMXadv(itrc), 'long_name', 
     &                          lvar, text(1:lvar))
# endif
          lvar=lenstr(vname(3,indxMXadv+itrc-1))
          ierr=nf_put_att_text (ncid, vidMXadv(itrc), 'units', lvar,
     &                          vname(3,indxMXadv+itrc-1)(1:lvar))
          lvar=lenstr(vname(4,indxMXadv+itrc-1))
          ierr=nf_put_att_text (ncid,vidMXadv(itrc), 'field',
     &                      lvar, vname(4,indxMXadv+itrc-1)(1:lvar))
!
! indxMYadv
!
          lvar=lenstr(vname(1,indxMYadv+itrc-1))
          ierr=nf_def_var (ncid, vname(1,indxMYadv+itrc-1)(1:lvar),
     &                     NF_FOUT, 4, r3dgrd, vidMYadv(itrc))
# ifndef AVRH
          lvar=lenstr(vname(2,indxMYadv+itrc-1))
          ierr=nf_put_att_text (ncid, vidMYadv(itrc), 'long_name',
     &                     lvar, vname(2,indxMYadv+itrc-1)(1:lvar))
# else
          text='averaged '/ /vname(2,indxMYadv+itrc-1)
          lvar=lenstr(text)
          ierr=nf_put_att_text (ncid, vidMYadv(itrc), 'long_name', 
     &                          lvar, text(1:lvar))
# endif
          lvar=lenstr(vname(3,indxMYadv+itrc-1))
          ierr=nf_put_att_text (ncid, vidMYadv(itrc), 'units', lvar,
     &                          vname(3,indxMYadv+itrc-1)(1:lvar))
          lvar=lenstr(vname(4,indxMYadv+itrc-1))
          ierr=nf_put_att_text (ncid,vidMYadv(itrc), 'field',
     &                      lvar, vname(4,indxMYadv+itrc-1)(1:lvar))
!
! indxMVadv
!
          lvar=lenstr(vname(1,indxMVadv+itrc-1))
          ierr=nf_def_var (ncid, vname(1,indxMVadv+itrc-1)(1:lvar),
     &                     NF_FOUT, 4, r3dgrd, vidMVadv(itrc))
# ifndef AVRH
          lvar=lenstr(vname(2,indxMVadv+itrc-1))
          ierr=nf_put_att_text (ncid, vidMVadv(itrc), 'long_name',
     &                    lvar, vname(2,indxMVadv+itrc-1)(1:lvar))
# else
          text='averaged '/ /vname(2,indxMVadv+itrc-1)
          lvar=lenstr(text)
          ierr=nf_put_att_text (ncid, vidMVadv(itrc), 'long_name', 
     &                          lvar, text(1:lvar))
# endif
          lvar=lenstr(vname(3,indxMVadv+itrc-1))
          ierr=nf_put_att_text (ncid, vidMVadv(itrc), 'units', lvar,
     &                          vname(3,indxMVadv+itrc-1)(1:lvar))
          lvar=lenstr(vname(4,indxMVadv+itrc-1))
          ierr=nf_put_att_text (ncid,vidMVadv(itrc), 'field',
     &                      lvar, vname(4,indxMVadv+itrc-1)(1:lvar))
!
! indxMCor
!
          lvar=lenstr(vname(1,indxMCor+itrc-1))
          ierr=nf_def_var (ncid, vname(1,indxMCor+itrc-1)(1:lvar),
     &                     NF_FOUT, 4, r3dgrd, vidMCor(itrc))
# ifndef AVRH
          lvar=lenstr(vname(2,indxMCor+itrc-1))
          ierr=nf_put_att_text (ncid, vidMCor(itrc), 'long_name',
     &                      lvar, vname(2,indxMCor+itrc-1)(1:lvar))
# else
          text='averaged '/ /vname(2,indxMCor+itrc-1)
          lvar=lenstr(text)
          ierr=nf_put_att_text (ncid, vidMCor(itrc), 'long_name',
     &                          lvar, text(1:lvar))
# endif
          lvar=lenstr(vname(3,indxMCor+itrc-1))
          ierr=nf_put_att_text (ncid, diaMCor(itrc), 'units', lvar,
     &                          vname(3,indxMCor+itrc-1)(1:lvar))
          lvar=lenstr(vname(4,indxMCor+itrc-1))
          ierr=nf_put_att_text (ncid,vidMCor(itrc), 'field',
     &                      lvar, vname(4,indxMCor+itrc-1)(1:lvar))
!
! indxMPrsgrd
!
          lvar=lenstr(vname(1,indxMPrsgrd+itrc-1))
          ierr=nf_def_var (ncid, vname(1,indxMPrsgrd+itrc-1)(1:lvar),
     &                     NF_FOUT, 4, r3dgrd, vidMPrsgrd(itrc))
# ifndef AVRH
          lvar=lenstr(vname(2,indxMPrsgrd+itrc-1))
          ierr=nf_put_att_text (ncid, vidMPrsgrd(itrc), 'long_name',
     &                      lvar, vname(2,indxMPrsgrd+itrc-1)(1:lvar))
# else
          text='averaged '/ /vname(2,indxMPrsgrd+itrc-1)
          lvar=lenstr(text)
          ierr=nf_put_att_text (ncid, vidMPrsgrd(itrc), 'long_name',
     &                          lvar, text(1:lvar))
# endif
          lvar=lenstr(vname(3,indxMPrsgrd+itrc-1))
          ierr=nf_put_att_text (ncid, diaMPrsgrd(itrc), 'units', lvar,
     &                          vname(3,indxMPrsgrd+itrc-1)(1:lvar))
          lvar=lenstr(vname(4,indxMPrsgrd+itrc-1))
          ierr=nf_put_att_text (ncid,vidMPrsgrd(itrc), 'field',
     &                      lvar, vname(4,indxMPrsgrd+itrc-1)(1:lvar))
!
! indxMHmix
!
          lvar=lenstr(vname(1,indxMHmix+itrc-1))
          ierr=nf_def_var (ncid, vname(1,indxMHmix+itrc-1)(1:lvar),
     &                     NF_FOUT, 4, r3dgrd, vidMHmix(itrc))
# ifndef AVRH
          lvar=lenstr(vname(2,indxMHmix+itrc-1))
          ierr=nf_put_att_text (ncid, vidMHmix(itrc), 'long_name',
     &                      lvar, vname(2,indxMHmix+itrc-1)(1:lvar))
# else
          text='averaged '/ /vname(2,indxMHmix+itrc-1)
          lvar=lenstr(text)
          ierr=nf_put_att_text (ncid, vidMHmix(itrc), 'long_name',
     &                          lvar, text(1:lvar))
# endif
          lvar=lenstr(vname(3,indxMHmix+itrc-1))
          ierr=nf_put_att_text (ncid, diaMHmix(itrc), 'units', lvar,
     &                          vname(3,indxMHmix+itrc-1)(1:lvar))
          lvar=lenstr(vname(4,indxMHmix+itrc-1))
          ierr=nf_put_att_text (ncid,vidMHmix(itrc), 'field',
     &                      lvar, vname(4,indxMHmix+itrc-1)(1:lvar))
!
!indxMVmix
!
          lvar=lenstr(vname(1,indxMVmix+itrc-1))
          ierr=nf_def_var (ncid, vname(1,indxMVmix+itrc-1)(1:lvar),
     &                     NF_FOUT, 4, r3dgrd, vidMVmix(itrc))
# ifndef AVRH
          lvar=lenstr(vname(2,indxMVmix+itrc-1))
          ierr=nf_put_att_text (ncid, vidMVmix(itrc), 'long_name',
     &                    lvar, vname(2,indxMVmix+itrc-1)(1:lvar))
# else
          text='averaged '/ /vname(2,indxMVmix+itrc-1)
          lvar=lenstr(text)
          ierr=nf_put_att_text (ncid, vidMVmix(itrc), 'long_name', 
     &                          lvar, text(1:lvar))
# endif
          lvar=lenstr(vname(3,indxMVmix+itrc-1))
          ierr=nf_put_att_text (ncid, diaMVmix(itrc), 'units', lvar,
     &                          vname(3,indxMVmix+itrc-1)(1:lvar))
          lvar=lenstr(vname(4,indxMVmix+itrc-1))
          ierr=nf_put_att_text (ncid,vidMVmix(itrc), 'field',
     &                      lvar, vname(4,indxMVmix+itrc-1)(1:lvar))
!
! Mrate indxMrate
!
          lvar=lenstr(vname(1,indxMrate+itrc-1))
          ierr=nf_def_var (ncid, vname(1,indxMrate+itrc-1)(1:lvar),
     &                     NF_FOUT, 4, r3dgrd, vidMrate(itrc))
# ifndef AVRH
          lvar=lenstr(vname(2,indxMrate+itrc-1))
          ierr=nf_put_att_text (ncid, vidMrate(itrc), 'long_name', 
     &                    lvar, vname(2,indxMrate+itrc-1)(1:lvar))
# else
          text='averaged '/ /vname(2,indxMrate+itrc-1)
          lvar=lenstr(text)
          ierr=nf_put_att_text (ncid, vidMrate(itrc), 'long_name', 
     &                          lvar, text(1:lvar))
# endif
          lvar=lenstr(vname(3,indxMrate+itrc-1))
          ierr=nf_put_att_text (ncid, vidMrate(itrc),'units',
     &                    lvar, vname(3,indxMrate+itrc-1)(1:lvar))
          lvar=lenstr(vname(4,indxMrate+itrc-1))
          ierr=nf_put_att_text (ncid, vidMrate(itrc),'field',
     &                    lvar, vname(4,indxMrate+itrc-1)(1:lvar))
        end do
!
#endif /* DIAGNOSTICS_UV */
!
! Leave definition mode.
! ----- ---------- -----
!
        ierr=nf_enddef(ncid)
        write(stdout,'(6x,4A,1x,A,i4)') 
#ifdef AVRH
     &        'DEF_DIAG_AVG - Created ',
#else      
     &        'DEF_DIAG - Created ',
#endif /*AVRH*/
     &                'new netCDF file ''', 
     &                 ncname(1:lstr), '''.'
     &                 MYID
!
! Open an existing file and prepare for appending data.
! ==== == ======== ==== === ======= === ========= =====
! Inquire about the dimensions and variables. Check for
! consistency with model dimensions. In the case when file 
! is rejected (whether it cannot be opened, or something
! is wrong with its dimensions) create a new file.2
!
! After that verify that all necessary variables are already
! defined there and find their netCDF IDs.
!
      elseif (ncid.eq.-1) then
        ierr=nf_open (ncname(1:lstr), nf_write, ncid)
        if (ierr. ne. nf_noerr) then
          ierr=checkdims (ncid, ncname(1:lstr), lstr, rec) 
          if (ierr .eq. nf_noerr) then
            if (rec_per_file.eq.0) then
              ierr=rec+1 - total_rec
            else
              ierr=rec+1 - (1+mod(total_rec-1, rec_per_file))
            endif
            if (ierr.gt.0) then
              MPI_master_only write( stdout,
     &                 '(/1x,A,I5,1x,A/8x,3A,I5,/8x,A,I5,1x,A/)'
     &     ) 'DEF_DIAGS/DIAGS_AVG WARNING: Actual number of records',
     &               rec,  'in netCDF file',  '''',  ncname(1:lstr),
     &             ''' exceeds the record number from restart data',
     &             rec+1-ierr,'/', total_rec,', restart is assumed.'
              rec=rec-ierr
            elseif (rec_per_file.eq.0) then
              total_rec=rec+1           ! <-- set to the next record
#if defined MPI & !defined PARALLEL_FILES
              if (mynode.gt.0) total_rec=total_rec-1
#endif
            endif
            ierr=nf_noerr
          endif
        endif
!
        if (ierr. ne. nf_noerr) then
#if defined MPI & !defined PARALLEL_FILES
          if (mynode.eq.0) then
            create_new_file=.true.
            goto 10
          else
        write(stdout,'(/1x,4A,2x,A,I4/)') 'DEF_DIAGS_HIS/AVG ERROR: ',
     &         'Cannot open file ''', ncname(1:lstr), '''.'
     &                   MYID
            goto 99                                       !--> ERROR
          endif
#else
          create_new_file=.true.
          goto 10
#endif
        endif
!
! Find netCDF IDs of evolving model variables:
! ---- ------ --- -- -------- ----- ----------
!
! Time step indices:
!         
        ierr=nf_inq_varid (ncid, 'time_step', vidTstep)
        if (ierr .ne. nf_noerr) then
          write(stdout,1) 'time_step', ncname(1:lstr)
          goto 99                                         !--> ERROR
        endif
!
! Time.
!
        lvar=lenstr(vname(1,indxTime))
        ierr=nf_inq_varid (ncid,vname(1,indxTime)(1:lvar),vidTime)
        if (ierr .ne. nf_noerr) then
          write(stdout,1) vname(1,indxTime)(1:lvar), ncname(1:lstr)
          goto 99                                         !--> ERROR 
        endif
!
! Tracer flux diagnostics variables :
! ------ ---- ----------- --------- 
!
#ifdef DIAGNOSTICS_TS
!
        do itrc=1,NT
!
! indxTXadv
!
          lvar=lenstr(vname(1,indxTXadv+itrc-1))
          ierr=nf_inq_varid (ncid, vname(1,indxTXadv+itrc-1)(1:lvar),
     &                                               vidTXadv(itrc))
          if (ierr .ne. nf_noerr) then
            write(stdout,1) vname(1,indxTXadv+itrc-1)(1:lvar),
     &                                         ncname(1:lstr) 
            goto 99                                       !--> ERROR
          endif
!
! indxTYadv
!
          lvar=lenstr(vname(1,indxTYadv+itrc-1))
          ierr=nf_inq_varid (ncid, vname(1,indxTYadv+itrc-1)(1:lvar),
     &                                               vidTYadv(itrc))
          if (ierr .ne. nf_noerr) then
            write(stdout,1) vname(1,indxTYadv+itrc-1)(1:lvar),
     &                                         ncname(1:lstr) 
            goto 99                                       !--> ERROR
          endif                                 
!
! indxTVadv
!
          lvar=lenstr(vname(1,indxTVadv+itrc-1))
          ierr=nf_inq_varid (ncid, vname(1,indxTVadv+itrc-1)(1:lvar),
     &                                               vidTVadv(itrc))
          if (ierr .ne. nf_noerr) then
            write(stdout,1) vname(1,indxTVadv+itrc-1)(1:lvar),
     &                                         ncname(1:lstr) 
            goto 99                                       !--> ERROR
          endif
!
! indxTHmix
!
          lvar=lenstr(vname(1,indxTHmix+itrc-1))
          ierr=nf_inq_varid (ncid, vname(1,indxTHmix+itrc-1)(1:lvar),
     &                                               vidTHmix(itrc))
          if (ierr .ne. nf_noerr) then
            write(stdout,1) vname(1,indxTHmix+itrc-1)(1:lvar),
     &                                         ncname(1:lstr)
            goto 99                                       !--> ERROR
          endif
!
! indxTVmix
!
          lvar=lenstr(vname(1,indxTVmix+itrc-1))
          ierr=nf_inq_varid (ncid, vname(1,indxTVmix+itrc-1)(1:lvar),
     &                                               vidTVmix(itrc))
          if (ierr .ne. nf_noerr) then
            write(stdout,1) vname(1,indxTVmix+itrc-1)(1:lvar),
     &                                         ncname(1:lstr) 
            goto 99                                       !--> ERROR
          endif
!
! indxTbody
!
          lvar=lenstr(vname(1,indxTbody+itrc-1))
          ierr=nf_inq_varid (ncid, vname(1,indxTbody+itrc-1)(1:lvar),
     &                                               vidTbody(itrc))
          if (ierr .ne. nf_noerr) then
            write(stdout,1) vname(1,indxTbody+itrc-1)(1:lvar),
     &                                         ncname(1:lstr) 
            goto 99                                       !--> ERROR
          endif
!
! indxTrate
!
          lvar=lenstr(vname(1,indxTrate+itrc-1))
          ierr=nf_inq_varid (ncid, vname(1,indxTrate+itrc-1)(1:lvar),
     &                                               vidTrate(itrc))
          if (ierr .ne. nf_noerr) then
            write(stdout,1) vname(1,indxTrate+itrc-1)(1:lvar),
     &                                         ncname(1:lstr) 
            goto 99                                       !--> ERROR
          endif
!
        enddo
!
        write(*,'(6x,2A,i4,1x,A,i4)') 'DEF_DIAG -- Opened ',
     &                     'existing file  from record =', rec
     &                      MYID
!
#endif /* DIAGNOSTICS_TS  */
!
! momentum flux diagnostics variables :
! -------- ---- ----------- ----------
!
#ifdef DIAGNOSTICS_UV
!
        do itrc=1,2  ! use itrc indice = 1 for u_momentum
!                    !                 = 2 for v_momentum 
! indxMXadv
!
         lvar=lenstr(vname(1,indxMXadv+itrc-1))
         ierr=nf_inq_varid (ncid, vname(1,indxMXadv+itrc-1)(1:lvar),
     &                      vidMXadv(itrc))
         if (ierr .ne. nf_noerr) then
           write(stdout,1) vname(1,indxMXadv+itrc-1)(1:lvar),
     &                     ncname(1:lstr) 
           goto 99                                       !--> ERROR
         endif
!
! indxMYadv
!
         lvar=lenstr(vname(1,indxMYadv+itrc-1))
         ierr=nf_inq_varid (ncid, vname(1,indxMYadv+itrc-1)(1:lvar),
     &                      vidMYadv(itrc))
         if (ierr .ne. nf_noerr) then
           write(stdout,1) vname(1,indxMYadv+itrc-1)(1:lvar),
     &                     ncname(1:lstr) 
           goto 99                                       !--> ERROR
         endif                                 
!
! indxMVadv
!
         lvar=lenstr(vname(1,indxMVadv+itrc-1))
         ierr=nf_inq_varid (ncid, vname(1,indxMVadv+itrc-1)(1:lvar),
     &                      vidMVadv(itrc))
         if (ierr .ne. nf_noerr) then
           write(stdout,1) vname(1,indxMVadv+itrc-1)(1:lvar),
     &                     ncname(1:lstr) 
           goto 99                                       !--> ERROR
         endif
!
! indxMCor
!
         lvar=lenstr(vname(1,indxMCor+itrc-1))
         ierr=nf_inq_varid (ncid, vname(1,indxMCor+itrc-1)(1:lvar),
     &                      vidMCor(itrc))
         if (ierr .ne. nf_noerr) then
           write(stdout,1) vname(1,indxMCor+itrc-1)(1:lvar),
     &                     ncname(1:lstr)
           goto 99                                       !--> ERROR
         endif
!
! indxMPrsgrd
!
         lvar=lenstr(vname(1,indxMPrsgrd+itrc-1))
         ierr=nf_inq_varid (ncid, vname(1,indxMPrsgrd+itrc-1)(1:lvar),
     &                      vidMPrsgrd(itrc))
         if (ierr .ne. nf_noerr) then
           write(stdout,1) vname(1,indxMPrsgrd+itrc-1)(1:lvar),
     &                     ncname(1:lstr)
           goto 99                                       !--> ERROR
         endif
!
! indxMHmix
!
         lvar=lenstr(vname(1,indxMHmix+itrc-1))
         ierr=nf_inq_varid (ncid, vname(1,indxMHmix+itrc-1)(1:lvar),
     &                      vidMHmix(itrc))
         if (ierr .ne. nf_noerr) then
           write(stdout,1) vname(1,indxMHmix+itrc-1)(1:lvar),
     &                     ncname(1:lstr)
           goto 99                                       !--> ERROR
         endif
!
! indxMVmix
!
         lvar=lenstr(vname(1,indxMVmix+itrc-1))
         ierr=nf_inq_varid (ncid, vname(1,indxMVmix+itrc-1)(1:lvar),
     &                      vidMVmix(itrc))
         if (ierr .ne. nf_noerr) then
           write(stdout,1) vname(1,indxMVmix+itrc-1)(1:lvar),
     &                     ncname(1:lstr) 
           goto 99                                       !--> ERROR
         endif
!
! indxMrate
!
         lvar=lenstr(vname(1,indxMrate+itrc-1))
         ierr=nf_inq_varid (ncid, vname(1,indxMrate+itrc-1)(1:lvar),
     &                      vidMrate(itrc))
         if (ierr .ne. nf_noerr) then
           write(stdout,1) vname(1,indxMrate+itrc-1)(1:lvar),
     &                     ncname(1:lstr) 
           goto 99                                       !--> ERROR
         endif
!
        enddo
!
        write(*,'(6x,2A,i4,1x,A,i4)') 'DEF_DIAG -- Opened ',
     &                     'existing file  from record =', rec
     &                      MYID
!
#endif /* DIAGNOSTICS_UV  */
!
        write(*,'(6x,2A,i4,1x,A,i4)') 'DEF_DIAG -- Opened ',
     &                     'existing file  from record =', rec
     &                      MYID
!
#if defined MPI & !defined PARALLEL_FILES
      else
        ierr=nf_open (ncname(1:lstr), nf_write, ncid)
        if (ierr .ne. nf_noerr) then
          write(stdout,'(/1x,4A,2x,A,I4/)') 'DEF_DIAG ERROR: ',
     &                'Cannot open file ''', ncname(1:lstr), '''.'
     &                 MYID
          goto 99                                         !--> ERROR
        endif
#endif
!
      endif             !<--  create_new_file  
!
      ierr=nf_set_fill (ncid, nf_nofill, lvar)
      if (ierr .ne. nf_noerr) then
        write(*,'(6x,2A,i4,1x,A,i4)') 'DEF_DIAG ERROR: Cannot ', 
     &    'switch to ''nf_nofill'' more; netCDF error code =', ierr 
      endif
   1  format(/1x,'DEF_DIAG ERROR: Cannot find variable ''',
     &                   A, ''' in netCDF file ''', A, '''.'/)
!
#if (defined PUT_GRID_INTO_HISTORY && !defined AVRH)\
 || (defined PUT_GRID_INTO_AVERAGES && defined AVRH)
!
! Write grid variables.
! ----- ---- ----------
!
      if (total_rec.le.1) call wrt_grid (ncid, ncname, lstr)
#endif
!
  11  format(/' DEF_DIAGS - unable to create diag file: ',a)
  20  format(/' DEF_DIAGS - error while writing variable: ',a,
     &        /,15x,'into diag  file: ',a)
!
  99  return
      end
!
#undef ncname
#undef rec_per_file
#undef wrt
#undef vidTime
#undef vidTstep
!
# ifdef DIAGNOSTICS_TS
#undef vidTXadv
#undef vidTYadv
#undef vidTVadv
#undef vidTHmix
#undef vidTVmix
#undef vidTbody
#undef vidTrate
# endif /* DIAGNOSTICS_TS */
!
# ifdef DIAGNOSTICS_UV
#undef vidMXadv
#undef vidMYadv
#undef vidMVadv
#undef vidMCor
#undef vidMPrsgrd
#undef vidMHmix
#undef vidMVmix
#undef vidMrate
# endif /* DIAGNOSTICS_UV */
!
# ifdef AVERAGES
#  ifndef AVRH
#   define AVRH
#   include "def_diags.F"
#   endif
#  endif /* AVERAGES */
!
#else /* DIAGNOSTICS_TS || DIAGNOSTICS_UV */
      subroutine def_diags_empty()
      return
      end
#endif /* DIAGNOSTICS_TS || DIAGNOSTICS_UV */

