!
! $Id: step.F,v 1.18 2005/10/26 15:18:52 pmarches Exp $
!
#include "cppdefs.h"
      subroutine step()
C$OMP PARALLEL
      call step_thread()
C$OMP END PARALLEL
      return
      end

      subroutine step_thread()
#ifdef AGRIF
      use Agrif_Util
#endif
      implicit none
#include "param.h"
#include "scalars.h"
#include "ncscrum.h"
#ifdef FLOATS
# include "floats.h"
#endif
#ifdef STATIONS
# include "sta.h"
#endif
      integer ntrds,trd, range,
     &        my_first,my_last, tile, my_iif
#ifdef AGRIF
     &      , Agrif_lev_sedim
#endif
#ifdef FLOATS
       integer chunk_size_flt, Lstr,Lend, flt_str
       common /floats_step/ flt_str
#endif
#ifdef STATIONS
       integer chunk_size_sta, Mcpstr,Mcpend, sta_str
       common /sta_step/ sta_str
#endif
      common /tile_ranges/ ntrds, trd, my_first,my_last
C$OMP THREADPRIVATE (/tile_ranges/)

      integer omp_get_num_threads, omp_get_thread_num 

#ifdef AGRIF
      Agrif_lev_sedim=Agrif_Nb_Fine_Grids()
#endif

      ntrds=omp_get_num_threads()
      trd=omp_get_thread_num()
C$OMP BARRIER
      range=(NSUB_X*NSUB_E+ntrds-1)/ntrds
      my_first=trd*range
      my_last=min(my_first + range-1, NSUB_X*NSUB_E-1)

C$OMP MASTER
#ifdef AGRIF
      iic=ntstart+Agrif_Nb_Step()
#endif

      time=time_start+dt*float(iic-ntstart)
      tdays=time*sec2day

#ifdef SOLVE3D
      nstp=1+mod(iic-ntstart,2)
      nrhs=nstp
      nnew=3
#endif

#ifdef FLOATS
      nfp1=MOD(nfp1+1,NFT+1)  ! Shift time indices
      nf  =MOD(nf  +1,NFT+1)  ! for floats
      nfm1=MOD(nfm1+1,NFT+1)
      nfm2=MOD(nfm2+1,NFT+1)
      nfm3=MOD(nfm3+1,NFT+1)
      flt_str=0
#endif
#ifdef STATIONS
      sta_str=0
#endif
#if defined AGRIF
      Agrif_lev_sedim=Agrif_Nb_Fine_Grids()
#endif

!
! Model input block: read forcing/climatology data from netCDF files.
!------ ----- ------ ---- ------------------- ---- ---- ------ ------
!
      if (synchro_flag) then
#ifdef AGRIF
        IF (Agrif_Root()) THEN
#endif
#if defined SOLVE3D && defined TCLIMATOLOGY && !defined ANA_TCLIMA
            call get_tclima
#endif
#if defined M2CLIMATOLOGY && !defined ANA_M2CLIMA 
# if (defined M3CLIMATOLOGY && !defined ANA_M3CLIMA)
            call get_uclima
# endif
#endif
#if defined ZCLIMATOLOGY && !defined ANA_SSH
            call get_ssh
#endif
#ifdef FRC_BRY
# ifndef ANA_BRY
            call get_bry
# endif
#endif
#ifdef AGRIF
        ENDIF
#endif
        call get_vbc
#if defined BBL && !defined ANA_WWAVE
# ifdef AGRIF
        IF (Agrif_Fixed().EQ.Agrif_lev_sedim) THEN
# endif
          call get_wwave
# ifdef AGRIF
        ENDIF
# endif
#endif /* BBL && !ANA_WWAVE*/
        synchro_flag=.false.
      endif  !<-- synchro_flag
C$OMP END MASTER
C$OMP BARRIER

      if (may_day_flag.ne.0) return  !-->  EXIT

#ifdef SOLVE3D

      do tile=my_first,my_last
# ifdef AGRIF
        IF (Agrif_Root()) THEN
# endif
# ifdef TCLIMATOLOGY
!#  ifdef ANA_TCLIMA
          call ana_tclima (tile)
!#  else
          call set_tclima (tile)
!#  endif
# endif
# if defined M2CLIMATOLOGY || defined M3CLIMATOLOGY
#  if defined ANA_M2CLIMA || defined ANA_M3CLIMA
          call ana_uclima (tile)
#  else
          call set_uclima (tile)
#  endif
# endif
# ifdef ZCLIMATOLOGY
#  ifdef ANA_SSH
          call ana_ssh (tile)
#  else
          call set_ssh (tile)
#  endif
# endif
# if  defined T_FRC_BRY  || defined M2_FRC_BRY || \
      defined M3_FRC_BRY || defined Z_FRC_BRY
#  ifdef ANA_BRY
          call ana_bry(tile)
#  else
          call set_bry(tile)
#  endif
# endif
# ifdef AGRIF
        ENDIF
# endif
        call rho_eos (tile)
        call set_HUV (tile)
# ifdef BIOLOGY
        call bio_diag (tile)
# else
        call diag(tile)
# endif
      enddo
C$OMP BARRIER

      do tile=my_first,my_last
        call set_vbc (tile)
# ifdef BBL
#  ifdef AGRIF
        IF (Agrif_Fixed().EQ.Agrif_lev_sedim) THEN
#  endif
#  ifdef ANA_WWAVE
          call ana_wwave (tile)
#  else
          call set_wwave (tile)
#  endif
          call bblm (tile)
#  ifdef AGRIF
        ENDIF
#  endif
# endif
# if defined SSH_TIDES || defined UV_TIDES
#  ifdef AGRIF
        IF (Agrif_Root()) call clm_tides (tile)
#  else
        call clm_tides (tile)
#  endif
# endif
      enddo
C$OMP BARRIER

      if (may_day_flag.ne.0) return  !-->  EXIT

      do tile=my_first,my_last
# if defined ANA_VMIX
        call ana_vmix (tile)
# elif defined LMD_MIXING
        call lmd_vmix (tile)
# elif defined BVF_MIXING
        call bvf_mix (tile)
# endif
        call omega (tile)
# if defined UV_VIS2 && defined SMAGORINSKY
        call smagorinsky (tile)
# endif
      enddo
C$OMP BARRIER
        
      do tile=my_first,my_last
        call prsgrd (tile)
        call rhs3d (tile)
        call pre_step3d (tile)
# if defined UV_VIS2 || defined UV_VIS4
        call uv3dmix (tile)
# endif
# ifdef AVERAGES
        call set_avg (tile)
#  if defined DIAGNOSTICS_TS || defined DIAGNOSTICS_UV
        call set_diags_avg (tile)
#  endif
# endif
      enddo
C$OMP BARRIER 
        
C$OMP MASTER
      nrhs=3
      nnew=3-nstp
!
! Output block: write restart/history files.   
!
      call output

C$OMP END MASTER
C$OMP BARRIER
#endif  /* SOLVE3D */

      if (may_day_flag.ne.0) return  !-->  EXIT

!
! Solve the 2D primitive equations for the barotropic mode.
!-------------------------------------------------------------
! Note that no actual fast-time-step is performed during the
! auxiliary (nfast+1)th step. It is needed to finalize the fast-time
! averaging procedure, if any, and to compute the total depth of
! water column, as well as the new vertical coordinate transformation
! profiles, z_r, z_w, because the free surface elevation has been
! changed. All these operations are done during predictor time step.
! Thus, there is no need for the corrector step during the auxiliary
! time step.
!
#ifdef SOLVE3D
      do my_iif=1,nfast+1
      iif=my_iif
#endif
C$OMP MASTER
        if (.not.PREDICTOR_2D_STEP) then
          PREDICTOR_2D_STEP=.TRUE.    
          kstp=next_kstp          
          krhs=kstp
          knew=3
        endif
C$OMP END MASTER
C$OMP BARRIER
!
! Model input block for 2D configurations only !!!
!
#ifndef SOLVE3D
# ifdef AGRIF
        IF (Agrif_Root()) THEN
# endif
          do tile=my_first,my_last
# if defined M2CLIMATOLOGY
#  if defined ANA_M2CLIMA
            call ana_uclima (tile)
#  else
            call set_uclima (tile)
#  endif
# endif
# ifdef ZCLIMATOLOGY
#  ifdef ANA_SSH
            call ana_ssh (tile)
#  else
            call set_ssh (tile)
#  endif
# endif
# if defined Z_FRC_BRY  || defined M2_FRC_BRY
#  ifdef ANA_BRY
            call ana_bry(tile)
#  else
            call set_bry(tile)
#  endif
# endif
          enddo
# ifdef AGRIF
        ENDIF
# endif
C$OMP BARRIER
        do tile=my_first,my_last
          call set_vbc (tile)
# if defined SSH_TIDES || defined UV_TIDES
#   ifdef AGRIF
          IF (Agrif_Root()) call clm_tides (tile)
#   else
          call clm_tides (tile)
#   endif
# endif
# ifdef AVERAGES
          call set_avg (tile)
# endif
        enddo
C$OMP BARRIER
C$OMP MASTER
        call output
C$OMP END MASTER
C$OMP BARRIER
#endif  /* !defined SOLVE3D */
        
        do tile=my_first,my_last
          call step2d (tile)
        enddo
C$OMP BARRIER
      
        if (may_day_flag.ne.0) return !-->  EXIT

C$OMP MASTER
        if (PREDICTOR_2D_STEP) then
          PREDICTOR_2D_STEP=.FALSE.
          krhs=3
          knew=3-kstp
          if (NOT_LAST_2D_STEP) next_kstp=knew
        endif
C$OMP END MASTER
C$OMP BARRIER

        if (NOT_LAST_2D_STEP) then
          do tile=my_first,my_last
            call step2d (tile)
          enddo
C$OMP BARRIER
        endif
                  
#ifdef SOLVE3D
      enddo     ! <-- my_iif

      do tile=my_first,my_last
        call set_HUV2 (tile)
      enddo
C$OMP BARRIER
      do tile=my_first,my_last
        call omega (tile)
        call rho_eos (tile)
      enddo
C$OMP BARRIER
      do tile=my_first,my_last
        call prsgrd (tile)
        call rhs3d (tile)
        call step3d_uv1 (tile)
      enddo
C$OMP BARRIER
      do tile=my_first,my_last
        call step3d_uv2 (tile)
      enddo
C$OMP BARRIER 
      do tile=my_first,my_last
        call omega (tile)
        call step3d_t (tile)
# ifdef SEDIMENT
#  ifdef AGRIF
        IF (Agrif_Fixed().EQ.Agrif_lev_sedim)
     &    call sediment (tile)
#  else
        call sediment (tile)
#  endif
# endif
# if defined TS_DIF2 || defined TS_DIF4
        call t3dmix (tile)
# endif
      enddo
C$OMP BARRIER
#endif /* SOLVE3D */

#ifdef FLOATS
      chunk_size_flt=32
      do while (flt_str.lt.nfloats) 
C$OMP CRITICAL
        Lstr=flt_str+1
        flt_str=Lstr+chunk_size_flt-1
C$OMP END CRITICAL
        Lend=min(Lstr+chunk_size_flt-1,nfloats)
        call step_floats (Lstr,Lend)
      enddo
c        call step_floats (1,nfloats) ! serial version for debugging
#endif /*FLOATS*/

#ifdef STATIONS
      chunk_size_sta=32
      do while (sta_str.lt.nstas)
C$OMP CRITICAL
        Mcpstr=sta_str+1
        sta_str=Mcpstr+chunk_size_sta-1
C$OMP END CRITICAL
        Mcpend=min(Mcpstr+chunk_size_sta-1,nstas)
        call step_sta (Mcpstr,Mcpend)
      enddo
#endif /*STATIONS*/
!
#if defined AGRIF && defined AGRIF_2WAY
!
! Update the outer domain after the last child step
! in case of 2-way nesting.
!
      if ((.Not.Agrif_Root()).and.
     &    (Agrif_NbStepInt()+1.eq.int(Agrif_Rhot()))) then
C$OMP MASTER
        call Agrif_update
C$OMP END MASTER
C$OMP BARRIER
      endif
#endif /*AGRIF && AGRIF_2WAY*/

      if (iic.eq.ntimes+1) return  !-->  DONE
      
      return
      end

